<?php
defined('BASEPATH') OR exit('No direct script access allowed');

/*
| -------------------------------------------------------------------------
| URI ROUTING
| -------------------------------------------------------------------------
| This file lets you re-map URI requests to specific controller functions.
|
| Typically there is a one-to-one relationship between a URL string
| and its corresponding controller class/method. The segments in a
| URL normally follow this pattern:
|
|	example.com/class/method/id/
|
| In some instances, however, you may want to remap this relationship
| so that a different class/function is called than the one
| corresponding to the URL.
|
| Please see the user guide for complete details:
|
|	https://codeigniter.com/user_guide/general/routing.html
|
| -------------------------------------------------------------------------
| RESERVED ROUTES
| -------------------------------------------------------------------------
|
| There are three reserved routes:
|
|	$route['default_controller'] = 'welcome';
|
| This route indicates which controller class should be loaded if the
| URI contains no data. In the above example, the "welcome" class
| would be loaded.
|
|	$route['404_override'] = 'errors/page_missing';
|
| This route will tell the Router which controller/method to use if those
| provided in the URL cannot be matched to a valid route.
|
|	$route['translate_uri_dashes'] = FALSE;
|
| This is not exactly a route, but allows you to automatically route
| controller and method names that contain dashes. '-' isn't a valid
| class or method name character, so it requires translation.
| When you set this option to TRUE, it will replace ALL dashes in the
| controller and method URI segments.
|
| Examples:	my-controller/index	-> my_controller/index
|		my-controller/my-method	-> my_controller/my_method
*/
$route['default_controller'] 				= "sitio";
$route['oferta'] 							= "sitio/oferta";
$route['prueba'] 							= "sitio/prueba";

$route['mapa'] 								= "sitio/mapa";
$route['prueba'] 							= "sitio/prueba";
$route['csv'] 								= "sitio/csv";
$route['paypal_transaction']				= "paypal/pay";

$route['eventos']							= 'noticias';
$route['eventos/(:any)']	        		= 'noticias/index/$1';
$route['evento/(:num)']	        			= 'noticias/single/$1';

//$route['(\w{2})/(.*)'] = '$2';
//$route['(\w{2})'] = $route['default_controller'];

$route['migracion']							= "migracion";
$route['migracion/(:any)']					= "migracion/$1";

$route['ofertas']							= "sitio/ofertas";
$route['faqs']								= "sitio/faqs";
$route['productos']							= "sitio/products";
$route['productos/(:any)']					= "sitio/products/$1";
$route['productos/(:any)/(:any)']			= "sitio/products/$1/$2";
$route['productos/(:any)/(:any)/(:num)']	= "sitio/products/$1/$2/$3";

$route['producto/(:num)']					= "sitio/product/$1";
$route['producto/(:num)/(:any)']			= "sitio/product/$1/$2";
//$route['(:any)/product/(:any)']				= "sitio/product/$2";

$route['contacto'] 							= "sitio/contact";
$route['index_2'] 							= "sitio/index_2";

$route['blog'] 								= "sitio/news";
$route['blog/(:any)'] 						= "sitio/news/$1";
$route['blog/(:any)/(:num)'] 				= "sitio/news/$1/$2";
$route['blog/(:num)'] 						= "sitio/news_single/$1";

$route['registro'] 							= "sitio/register";
$route['registro/(:any)/(:num)'] 			= "sitio/register/$1/$2";



$route['categoria/(:any)'] 					= "sitio/category/$1";
$route['en/category/(:any)'] 				= "sitio/category/$1";

$route['buscar']							= "sitio/buscar";

$route['carrito']							= "carrito";
$route['carrito/(:any)']					= "carrito/$1";
$route['paypal']							= "paypal";
$route['comprar']							= "sitio/order";
$route['comprar/(:any)']					= "sitio/order/$1";
$route['comprar/(:any)/(:any)']				= "sitio/order/$1/$2";
$route['olvido']							= "sitio/olvido";
$route['token/(:num)/(:any)']				= "sitio/token/$1/$2";
$route['logout']							= "sitio/logout";
$route['ajax/(:any)']						= "ajax/$1";
$route['novedades']							= "sitio/novedades";
$route['novedad/(:num)/(:any)']				= "sitio/novedad/$1";
//$route['facebook_login']					= "sitio/facebook_login";

$route['usuario/(:any)']					= 'user/$1';
$route['usuario/(:any)/(:num)']				= 'user/$1/$2';

$route['admin'] 							= "login/loginAdmin";
$route['admin/principal/set_dolar'] 		= "admin/main/set_dolar";
$route['admin/logout'] 						= "admin/main/logout";
$route['admin/principal'] 					= "admin/main";
$route['admin/datos'] 						= "admin/main/datos";
$route['admin/configuracion'] 				= "admin/main/config";
$route['admin/administradores'] 			= "admin/administradores";
$route['admin/administradores/(:any)'] 		= "admin/administradores/$1";
$route['admin/administradores/(:any)/(:num)'] = "admin/administradores/$1/$2";
$route['admin/resultados'] 					= "admin/main/resultados";
$route['admin/delete_keywords'] 			= "admin/main/delete_keywords";
$route['admin/ajax/(:any)'] 				= "admin/ajax/$1";
$route['admin/productos/(:any)']			= "admin/products/$1";
$route['admin/productos/(:any)/(:num)']		= "admin/products/$1/$2";
$route['admin/pedidos/(:any)']				= "admin/orders/$1";
$route['admin/pedidos/(:any)/(:num)']		= "admin/orders/$1/$2";
$route['admin/pedidos/(:any)/(:any)/(:num)']= "admin/orders/$1/$2/$3";
$route['admin/marcas/(:any)']				= "admin/brands/$1";
$route['admin/noticias/(:any)']				= "admin/noticias/$1";
$route['admin/categorias/(:any)']			= "admin/categories/$1";
$route['admin/categorias/(:any)/(:any)']			= "admin/categories/$1/$2";
$route['admin/slider/(:any)']				= "admin/slider/$1";
$route['admin/mensajes/(:any)']				= "admin/mensajes/$1";
$route['admin/preguntas/(:any)']			= "admin/preguntas/$1";
$route['admin/usuarios/(:any)']				= "admin/users/$1";
$route['admin/usuarios/(:any)/(:num)']		= "admin/users/$1/$2";
$route['admin/edicion/img/(:any)/(:any)']	= "admin/edition/img/$1/$2";
$route['admin/edicion/img/(:any)/(:any)']	= "admin/edition/img/$1/$2";
$route['admin/edicion/img/(:any)/(:any)/(:any)']	= "admin/edition/img/$1/$2/$3";
$route['admin/ofertas'] 					= "admin/ofertas";
$route['admin/ofertas/(:any)'] 			    = "admin/ofertas/$1";
$route['admin/ofertas/(:any)/(:num)'] 		= "admin/ofertas/$1/$2";


$route['admin/armado'] 						= "admin/armado";
$route['admin/armado/(:any)'] 			    = "admin/armado/$1";
$route['admin/armado/(:any)/(:num)'] 		= "admin/armado/$1/$2";

$route['admin/metodos'] 					= "admin/metodos";
$route['admin/metodos/(:any)'] 			    = "admin/metodos/$1";
$route['admin/metodos/(:any)/(:num)'] 		= "admin/metodos/$1/$2";


$route['admin/faqs'] 						= "admin/faqs";
$route['admin/faqs/(:any)'] 			    = "admin/faqs/$1";
$route['admin/faqs/(:any)/(:num)'] 			= "admin/faqs/$1/$2";

$route['admin/settings'] 					= "admin/settings";


$route['(:any)/(:any)']						= "sitio/statics/$2";
$route['(:any)']							= "sitio/statics/$1";


$route['404_override'] 						= '';
