<?php if( ! defined('BASEPATH')) exit('No direct script access allowed');

class Noticias extends CI_Controller
{

	private $resultados = 10;

	public function __construct()
	{
		parent::__construct();
		$this->load->model('newsmodel');
		$this->load->model('newscatmodel');
	}

	public function index($categoria = false)
	{

		$head = array(

			'title' 	=> 'Eventos y novedades | ' . $this->config->item('site_name') ,
		);

		$this->templates->head( $head );
		$this->templates->header();

		$data = array(

			'noticias'		=> $this->newsmodel->get(true, 0, 16, $categoria),
			'categoria'		=> $categoria ? $this->newscatmodel->singleCategoryFromSlug($categoria) : false,
		);

		$this->load->view('site/noticias', $data);

		$this->templates->footer();
	}

	public function single($id = false)
	{
		if(!$id) show_404();

		//$noticia = $this->newsmodel->single($id);

		$noticia = new stdClass();
		$noticia->title = 'Evento ' . ($id + 1);
		$noticia->id = $id;

		//if(!$noticia) show_404();

		$head = array(

			'title' 	=> $noticia->title. ' | ' . $this->config->item('site_name'),
		);

		$this->templates->head( $head );
		$this->templates->header();

		$data = array(

			'noticia'		=> $noticia,
			'relevants'		=> $this->newsmodel->relevants($id, 3)

		);

		//$this->templates->sidebar($data);

		$this->load->view('site/noticia_single', $data);

		$this->templates->footer();
	}

	public function buscar()
	{

		$keyword = html_escape($this->security->xss_clean($this->input->post('keyword', true)));

		$head = array(

			'title' 	=> 'Buscador de Novedades | ' . $this->config->item('site_name'),
		);

		$this->templates->head( $head );
		$this->templates->header();

		$data = array(

			'noticias'		=> $this->newsmodel->search($keyword),
			'keyword'		=> $keyword
		);

		$this->templates->sidebar();

		$this->load->view('site/noticias_buscar', $data);

		$this->templates->footer();
	}

	private function paginador($base_url, $total_rows = 0, $uri_segment = 3)
	{
		$this->load->library('pagination');

		$config = array(

            'base_url'      => $base_url,
            'total_rows'    => $total_rows,
            'per_page'      => $this->resultados,
            'uri_segment'   => $uri_segment,
            'full_tag_open' => '<div id="paginador">',
            'full_tag_close'=> '</div>',
            'first_link'	=> 'Primera',
            'last_link'		=> 'Última',
        );

        $this->pagination->initialize($config);

		return $this->pagination->create_links();
	}


}
