<?php

class User extends CI_Controller
{

	public function __construct()
	{
		parent::__construct();
		$this->load->model('productsmodel');
		$this->load->model('statusmodel');
		$this->load->model('usersmodel');
		
		$this->statusmodel->checkUser();
	}

	public function datos($extra=false)
	{
		$this->functions->setUrlReferer();
		
		$this->templates->head( array('title' => 'Mis Datos', 'description' => '') );
		

		if($this->session->userdata('logged_user'))
		{
			$data['success'] = false;
			$data['user'] = $this->usersmodel->single( $this->session->userdata('id_user') );

			if(!$data['user'])
			{
				die('Error');
			}

			if( isset($_POST['enviar']) )
			{
				if( $this->form_validation->run('data') )
				{
					$data = array(

						'name'			=> $this->input->post('name', true),
						'lastname'		=> $this->input->post('lastname', true),
						'mail'			=> $this->input->post('mail', true),
						'address'		=> $this->input->post('address', true),
						'tel'			=> $this->input->post('tel', true),
						'pass'			=> ($this->input->post('password') != '' ? md5($this->input->post('password', true) ) : $data['user']->pass)
					);

					if( $this->usersmodel->update($this->session->userdata('id_user'), $data) )
					{
						$user = $this->usersmodel->single( $this->session->userdata('id_user') );
						$this->statusmodel->setUserSession($user);
						$data['success'] = true;

						if($extra)
						{
							redirect('carrito/' . $extra);
						}
						else
						{
							redirect('');
						}

					}

				}
			}
			$this->templates->header();
			//$this->sidebar('Mis Datos');
			$this->load->view('site/data', $data);			
		}
		else
		{
			$this->templates->header();
			$this->load->view('site/not_allowed');
		}

		$this->templates->footer();
	}

	public function compras()
	{
		$this->functions->setUrlReferer();
		$this->load->model('ordersmodel');
		
		$this->templates->head( array('title' => 'Mis Compras', 'description' => '') );
		$this->templates->header();

		if($this->session->userdata('logged_user'))
		{
			$data['compras']	= $this->ordersmodel->get( $this->session->userdata('id_user') );
			//$this->sidebar('Compras Realizadas');
			$this->load->view('site/bought', $data);
		}
		else
		{
			$this->load->view('site/not_allowed');
		}

		$this->templates->footer();
	}

	public function favoritos($inicio = 0)
	{
		$this->functions->setUrlReferer();
		$this->load->model('favoritosmodelo');
		
		$this->templates->head( array('title' => 'Mis Favoritos', 'description' => '') );
		$this->templates->header();

		if( $this->statusmodel->checkUser() )
		{
			$data['favoritos']	= $this->favoritosmodelo->listar( $this->session->userdata('id_user'), $inicio, 50 );
			//$this->sidebar('Mis Favoritos');
			$this->load->view('site/user-favorites', $data);			
		}
		else
		{
			$this->load->view('site/not_allowed');
		}

		$this->templates->footer();
	}

	private function sidebar($title)
	{
		$data['title']			= $title;

		$datos 					= new stdClass();
		$datos->titulo			= 'Mis Datos';
		$datos->url 			= 'usuario/datos';
		$datos->activo 			= uri_string() == $datos->url ? true : false;

		// $preguntas 				= new stdClass();
		// $preguntas->titulo		= 'Mis Preguntas';
		// $preguntas->url 		= 'usuario/preguntas';
		// $preguntas->activo 		= uri_string() == $preguntas->url ? true : false;

		$compras 				= new stdClass();
		$compras->titulo		= 'Compras realizadas';
		$compras->url 			= 'usuario/compras';
		$compras->activo 		= uri_string() == $compras->url ? true : false;

		$favoritos 				= new stdClass();
		$favoritos->titulo		= 'Mis favoritos';
		$favoritos->url 		= 'usuario/favoritos';
		$favoritos->activo 		= uri_string() == $favoritos->url ? true : false;

		$data['objetos'] = array(

			'datos'			=> $datos,
			'compras'		=> $compras,
			'favoritos'		=> $favoritos
		);

		$this->load->view('site/templates/sidebar-user', $data);
	}

}