<?php

class Administradores extends CI_Controller{


	public function __construct()
    {
        
        parent::__construct();
        $this->load->model('settingsmodel');
        $this->load->model('statusmodel');
        $this->load->model('adminmodel');
        $this->session->set_userdata('admin_menu', 'administradores');

        if( ! $this->statusmodel->loggedAdmin())
        {
            redirect('admin');
            exit();
        }

        if( $this->session->userdata('level_admin') != '2' )
        {
            show_404();
        }
        
    }

    
    public function index()
    {

        $this->templates_admin->head();
        $this->templates_admin->header(array('title' => 'Lista de administradores'));
        $this->templates_admin->subMenu(array('Nuevo+' => 'administradores/nuevo' ), false);

        $data['admins'] = $this->adminmodel->others($this->session->userdata('id_admin'));
        $this->load->view('admin/administradores/listar', $data);
        $this->templates_admin->footer();

    }

    public function nuevo()
    {

        $this->templates_admin->head();
        $this->templates_admin->header(array('title' => 'Lista de administradores'));
        $this->templates_admin->subMenu(array('Nuevo+' => 'administradores/nuevo' ), false);

        $data['error']      = false;
        $data['ingresado']  = false;

        if( isset($_POST['enviar']) )
        {

            if( $this->form_validation->run('admin') )
            {
                $datos = array(

                    'id'            => null,
                    'name'          => $this->input->post('name'),
                    'lastname'      => $this->input->post('lastname'),
                    'pass'          => md5($this->input->post('password')),
                    'mail'          => $this->input->post('mail'),
                    'level'         => $this->input->post('level'),
                    'active'        => 1

                );

                if( $this->adminmodel->add($datos) )
                {
                    $data['ingresado'] = true;
                }
                else
                {
                    $data['error'] = 'Se ha producido un error inesperado';
                }
            }
            else
            {
                $data['error'] = validation_errors();
            }

        }

        $data['admins'] = $this->adminmodel->others($this->session->userdata('id_admin'));
        $this->load->view('admin/administradores/nuevo', $data);
        $this->templates_admin->footer();
    }



    public function editar($id = false)
    {
        if(!$id)
        {
            show_404();
            exit();
        }

        $admin = $this->adminmodel->single($id);

        if(!$admin)
        {
            show_404();
            exit();
        }

        $data['editado']    = false;
        $data['error']      = false;

        $this->templates_admin->head();
        $this->templates_admin->header(array('title' => 'Lista de administradores'));
        $this->templates_admin->subMenu(array('Nuevo+' => 'administradores/nuevo' ), false);

        $data['admin'] = $admin;

        if( isset($_POST['enviar']) )
        {

            if( $this->form_validation->run('admin_edit') )
            {
                $datos = array(

                    'name'          => $this->input->post('name'),
                    'lastname'      => $this->input->post('lastname'),
                    'pass'          => $this->input->post('password') == '' ? $data['admin']->pass : md5($this->input->post('password')),
                    'mail'          => $this->input->post('mail'),
                    'level'         => $this->input->post('level')

                );

                if( $this->adminmodel->updateOther($datos, $data['admin']->id) )
                {
                    $data['editado'] = true;
                }
                else
                {
                    $data['error'] = 'Se ha producido un error inesperado';
                }
            }
            else
            {
                $data['error'] = validation_errors();
            }

        }

        $data['admins'] = $this->adminmodel->others($this->session->userdata('id_admin'));
        $this->load->view('admin/administradores/editar', $data);
        $this->templates_admin->footer();

    }















}



?>