<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Ajax extends CI_Controller{


    public function __construct()
    {
        parent::__construct();
        $this->load->model('searchmodel');
        $this->load->model('statusmodel');
        $this->load->model('settingsmodel');

        if( ! $this->statusmodel->loggedAdmin())
        {
            redirect('admin');
            exit();
        }
       
    }

    public function masivo($tipo = false, $action = false)
    {

        if(!$tipo || !$action) die();

        $items = $this->input->post('items', true);

        switch ($tipo)
        {
            case 'productos':

                $modelo = 'productsmodel';
                
            break;

            case 'categorias':

                $modelo = 'categoriesmodel';
                
            break;

            case 'pedidos':

                $modelo = 'ordersmodel';
                
            break;

            case 'slider':

                $modelo = 'slidermodel';
                
            break;

            case 'usuarios':

                $modelo = 'usersmodel';
                
            break;

            case 'noticias':

                $modelo = 'newsmodel';
                
            break;

            case 'cat_noticias':

                $modelo = 'newscatmodel';
                
            break;

            case 'imagenes':

                $modelo = 'imgmodel';
                
            break;
            
            default:
                die();
            break;
        }

        echo $this->functions->masivo($action, $items, $modelo);
    }

    public function orden()
    {
        $tipo = $this->input->post('tipo', true);

        if(!$tipo) return false;

        $tipos = array('slider', 'img', 'faqs');

        if(!in_array($tipo, $tipos)) die();

        if(isset($_POST['orden']))
        {
            $orden = $_POST['orden'];
            
            $orden = $this->security->xss_clean($orden);
            
            foreach($orden as $key=>$item)
            {
                $item       = explode('_', $item);
                $id         = $item[1];
                $posicion   = $key+1;

                $sql = "UPDATE $tipo SET $tipo.order = '".$posicion."' WHERE id = '".$id."'";
                $this->db->query($sql);
            }

        }
        else
        {
            return false;
        }
    }

    public function determinar_destacados($tipo, $id)
    {
        //header('Access-Control-Allow-Origin: *');
        $sql = "UPDATE products SET important = ".$tipo." WHERE products.id = ".$id;

        if($this->db->query($sql))
        {
            $data['success'] = true;      
        }
        else
        {
            $data['success'] = false;
        }

        echo json_encode($data);
    }


    public function autocompletar()
    {

        if(isset($_POST['termino']))
        {
            if(empty($_POST['termino']))
            {
                return false;
            }
            else
            {

                $res = $this->searchmodel->autocompletar($this->input->post('termino'));
            
                $i = 1;
                $cantidad = count($res);
                foreach ($res as $row)
                {
                    echo $row->name;
                    if($i < $cantidad)
                    {
                        echo ';';
                    }
                    $i++;
                }
            }

        }
    }

    public function autocompletarUsers()
    {
        $this->load->model('usersmodel');

        if(isset($_POST['termino']))
        {
            if(empty($_POST['termino']))
            {

                return false;
            }
            else
            {

                $res = $this->usersmodel->autocompletar($this->input->post('termino'));
            
                $i = 1;
                $cantidad = count($res);
                foreach ($res as $row)
                {
                    echo $row->mail;
                    if($i < $cantidad)
                    {
                        echo ';';
                    }
                    $i++;
                }
            }

        }
    }
    

    public function responder_pregunta($id = false)
    {
        $this->load->model('questionsmodel');


        if( $id == false )
        {
            return;
        }
        $preguntaObjeto = $this->questionsmodel->single($id);

        $data['exito'] = false;

        $pregunta['answer']         = $this->input->post('respuesta');
        $pregunta['date_answer']    = date("Y-m-d H:i:s");
        $pregunta['status']         = 'respondida';

        if( $this->questionsmodel->update($id, $pregunta) )
        {
            $data['exito'] = true;
            $this->load->model('usersmodel');
            $user = $this->usersmodel->single($preguntaObjeto->user);

            if($user != false)
            {
                 //mando mail al cliente
                $template['html'] = '<p>Su pregunta fue recibida con éxito</p>
                         
                                    <p>Pregunta : <br> '.$preguntaObjeto->question.' </p>

                                    <p>Respuesta : <br> '.$pregunta['answer'].' </p>';
                
                $template['site_name']  = $this->settingsmodel->variable('site_name');

                $html = $this->load->view('email', $template, true);

                $email = array(

                    'to'            => $user->mail,
                    'reply_to'      => $this->config->item('email_to'),
                    'subject'       => 'Su pregunta ha sido respondida',
                    'html'          => $html
                
                );

                $this->functions->sendEmail($email);
            }
            
        }

        echo json_encode($data);

    }

}
?>