<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Armado extends CI_Controller{


    public function __construct()
    {
        parent::__construct();

        $this->load->model('settingsmodel');
        $this->load->model('statusmodel');
        $this->load->model('armadomodelo');

        $this->session->set_userdata('admin_menu', 'armado');

        if( ! $this->statusmodel->loggedAdmin())
        {
            redirect('admin');
            exit();
        }
    }

    public function index()
    {
        $this->templates_admin->head();
        $this->templates_admin->header(array('title' => 'Lista de armados'));
        $this->templates_admin->sidebar();
        $this->templates_admin->subMenu(array(), false, true, 'armado');
        
        $data = array(

            'armados'    => $this->armadomodelo->get(0, 90000, 'precio DESC', false),

        );

        $this->load->view('admin/armado/listar', $data);

        $this->templates_admin->footer();
    }

    public function nuevo()
    {

        $data = array(

            'id_armado' => null,
            'nombre'    => html_escape( $this->input->post('nombre', true) ),
            'precio'    => html_escape( $this->input->post('precio', true) ),
            'activo'    => 1,
        );

        if( $this->armadomodelo->add($data) )
        {
            redirect('admin/armado');
        }
        else
        {
            die('Se ha producido un error.');
        }

    }

    public function actualizar()
    {
        //var_dump($_POST);

        if( !empty($_POST) )
        {
            foreach ($_POST['id_armado'] as $key => $id)
            {
                $data = array(

                    'nombre'        => html_escape( $_POST['nombre'][$key] ),
                    'precio'        => html_escape( $_POST['precio'][$key] ),
                    'activo'        => isset( $_POST['activo'][$key] ) ? 1 : 0
                );

                $this->armadomodelo->update($id, $data);

            }
        }

        redirect('admin/armado');
    }

    public function eliminar($id_armado = false)
    {   

        if( !$id_armado ) die();

        $this->armadomodelo->delete($id_armado);

        redirect('admin/armado');
    }

}
?>