<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Bultos extends CI_Controller{


    public function __construct()
    {
        parent::__construct();

        $this->load->model('settingsmodel');
        $this->load->model('statusmodel');
        $this->load->model('bultosmodelo');

        $this->session->set_userdata('admin_menu', 'bultos');

        if( ! $this->statusmodel->loggedAdmin())
        {
            redirect('admin');
            exit();
        }
    }

    public function index()
    {
        $this->templates_admin->head();
        $this->templates_admin->header(array('title' => 'Lista de bultos'));
        $this->templates_admin->sidebar();
        $this->templates_admin->subMenu(array(), false, true, 'bultos');
        
        $data = array(

            'bultos'    => $this->bultosmodelo->get(0, 90000, 'precio DESC', false),

        );

        $this->load->view('admin/bultos/listar', $data);

        $this->templates_admin->footer();
    }

    public function nuevo()
    {

        $data = array(

            'id_bulto'  => null,
            'nombre'    => html_escape( $this->input->post('nombre', true) ),
            'precio'    => html_escape( $this->input->post('precio', true) ),
            'activo'    => 1,
        );

        if( $this->bultosmodelo->add($data) )
        {
            redirect('admin/bultos');
        }
        else
        {
            die('Se ha producido un error.');
        }

    }

    public function actualizar()
    {
        //var_dump($_POST);

        if( !empty($_POST) )
        {
            foreach ($_POST['id_bulto'] as $key => $id)
            {
                $data = array(

                    'nombre'        => html_escape( $_POST['nombre'][$key] ),
                    'precio'        => html_escape( $_POST['precio'][$key] ),
                    'activo'        => isset( $_POST['activo'][$key] ) ? 1 : 0
                );

                $this->bultosmodelo->update($id, $data);

            }
        }

        redirect('admin/bultos');
    }

    public function eliminar($id_bulto = false)
    {   

        if( !$id_bulto ) die();

        $this->bultosmodelo->delete($id_bulto);

        redirect('admin/bultos');
    }

}
?>