<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Categories extends CI_Controller{

	private $tipo = "categorias";

	public function __construct()
	{
	   	parent::__construct();

	   	$this->load->model('settingsmodel');
	   	$this->load->model('statusmodel');
        $this->load->model('categoriesmodel');
        $this->load->library('upload');
        $this->session->set_userdata('admin_menu', 'categories');

        if( ! $this->statusmodel->loggedAdmin())
        {
            redirect('admin');
            exit();
        }
    }

	public function listar($id = false)
	{

		$this->templates_admin->head();
		$this->templates_admin->header(array('title' => 'Lista de categorias'));
        $this->templates_admin->sidebar();
        $this->templates_admin->subMenu(array('nueva+' => 'categorias/nueva'), false, true, 'categorias');
        
        $data['msj'] = "";
        $confirmar = false;

        if( !$id )
        {
            $data[$this->tipo]  = $this->categoriesmodel->mainCategories(false);
            $data['breadcrumb'] = "";

        }
        else
        {
            $data[$this->tipo]  = $this->categoriesmodel->getChilds($id, false);
            $data['breadcrumb'] = $this->breadcrumb($id);
        }
		
		$data['tipo']		= $this->tipo;

        $this->load->view('admin/'.$this->tipo.'/list', $data);

		$this->templates_admin->footer();
	}

    public function nueva()
    {
        
        $this->templates_admin->head();
        $this->templates_admin->header(array('title' => 'Nueva categoria'));
        $this->templates_admin->sidebar();

        $data = array(  

            'tipo'          => $this->tipo,
            'categories'    => $this->categoriesmodel->get(true),
            'added'         => false
        );
    
        if($this->form_validation->run('categories'))
        {
            if($this->input->post('slug') == "")
            {
                $slug = url_title($this->input->post('name'), '-', true);    
            }
            else
            {
                $slug = $this->input->post('slug');
            }
            
            if( $this->upload() )
            {
                $array = array(

                    'id'                => null,
                    'parent'            => $this->input->post('parent'),
                    'name'              => $this->input->post('name'),
                    'description'       => $this->input->post('description'),
                    'slug'              => $slug,
                    'active'            => 1
                );

                if($this->categoriesmodel->add($array))
                {
                    $id = $this->categoriesmodel->last();

                    if(mkdir('./img/categorias/'.$id, 0755))
                    {
                        if(@$_FILES['userfile']['name'] != '')
                        {
                            if(file_exists('./img/categorias/temp.jpg'))
                            {
                                if(copy('./img/categorias/temp.jpg', './img/categorias/'.$id.'/temp.jpg'))
                                {
                                    rename('./img/categorias/'.$id.'/temp.jpg','./img/categorias/'.$id.'/01.jpg');
                                    copy('./img/categorias/'.$id.'/01.jpg', './img/categorias/'.$id.'/02.jpg');
                                    unlink('./img/categorias/temp.jpg');
                          
                                }
                            }
                        }
    
                    }

                    $data['added'] = true;
                } 
            }

            
        }

        $accion = $data['added'] ? 'volver' : 'cancelar';

        $this->templates_admin->subMenu(array($accion => 'categorias/listar' ));

        $this->load->view('admin/'.$this->tipo.'/nuevo', $data);
        
        $this->templates_admin->footer();
    }

    public function editar($category)
    {
        $this->templates_admin->head();
        $this->templates_admin->header(array('title' => 'Editar producto'));
        $this->templates_admin->sidebar();

        $data['tipo']       = $this->tipo;  
        $data['categories'] = $this->categoriesmodel->mainCategories(true);
        $data['category']   = $this->categoriesmodel->single($category);

        if(isset($_POST['enviar']))
        {
            if($this->form_validation->run('categories'))
            {
                $slug = url_title($this->input->post('name'), '-', true);

                if( $this->upload() )
                {
                    $array = array(

                        'parent'        => $this->input->post('parent'),
                        'name'          => $this->input->post('name'),
                        'description'   => $this->input->post('description'),
                        'slug'          => url_title($this->input->post('name'), '-', true),
                        'active'        => $data['category']->active
                    );

                    if($this->categoriesmodel->update($category, $array))
                    {

                        if(isset($_FILES['userfile']))
                        {
                            if($_FILES['userfile']['name'] != '')
                            {

                                if( ! file_exists('./img/categorias/'.$category) )
                                {
                                    mkdir('./img/categorias/'.$category);
                                }

                                if(copy('./img/categorias/temp.jpg', './img/categorias/'.$category.'/temp.jpg'))
                                {
                                    rename('./img/categorias/'.$category.'/temp.jpg','./img/categorias/'.$category.'/01.jpg');
                                    copy('./img/categorias/'.$category.'/01.jpg', './img/categorias/'.$category.'/02.jpg');
                                    unlink('./img/categorias/temp.jpg');
                                }

                            }

                        }

                        redirect('admin/categorias/listar');
                    }
                }
            }
        }

        if(file_exists('./img/categorias/'.$category.'/01.jpg'))
        {
            $data['foto'] = base_url().'img/categorias/'.$category.'/02.jpg';
        }
        else
        {
            $data['foto'] = false;
        }

        $this->templates_admin->subMenu(array('cancelar' => 'categorias/listar' ));

        $this->load->view('admin/'.$this->tipo.'/edit', $data);
        
        $this->templates_admin->footer();
    }


    private function breadcrumb($id)
    {

        $categoria = $this->categoriesmodel->single($id);

        $salida     = false;
        $parents    = $this->categoriesmodel->getParents($id);

        $salida  = '<ol class="breadcrumb">';
        $salida .= '<li><a href="categorias/listar">Inicio</a></li>';

        if( !$parents == false )
        {
            foreach ($parents as $key => $category)
            {
                $salida .= '<li><a href="categorias/listar/' . $category->id . '">' . $category->name . '</a></li>';
            }
        }
        $salida .= '<li>' . $categoria->name . '</li>';
        $salida .= '</ol>';

       
        return $salida;

   }

    public function eliminar_foto($id = false)
    {
        if($id != false)
        {
            if(file_exists('./img/categorias/'.$id.'/01.jpg'))
            {
                unlink('./img/categorias/'.$id.'/01.jpg');
            }

            if(file_exists('./img/categorias/'.$id.'/02.jpg'))
            {
                unlink('./img/categorias/'.$id.'/02.jpg');
            }

            redirect('admin/categorias/editar/'.$id);

        }
        else
        {
            redirect(base_url());
        }
    }

    private function upload()
    {

        if(isset($_FILES['userfile']))
        {
            if($_FILES['userfile']['name'] != '')
            {
                $ext = pathinfo($_FILES['userfile']['name'], PATHINFO_EXTENSION);

                if(file_exists('./img/categorias/temp.'.$ext))
                {
                    unlink('./img/categorias/temp.'.$ext);
                }

                $config['upload_path'] = './img/categorias/';
                $config['file_name'] = 'temp.'.$ext;
                $config['allowed_types'] = 'jpg';
                $config['max_size'] = '2000';
                $this->upload->initialize($config);
                
                if( ! $this->upload->do_upload())
                {
                    return false;
                }
                else
                {
                    $this->ext_temp = $ext;
                    return true;
                }        
            }
        }

        return true;
    }

 



}