<?php

class Edition extends CI_Controller{

	public function __construct()
    {
	   	parent::__construct();
	   	$this->load->model('settingsmodel');
        $this->load->model('statusmodel');
        $this->load->model('productsmodel');
        $this->load->model('imgmodel');
	    
        $this->load->driver('cache');
        $this->cache->clean();
       	if( ! $this->statusmodel->loggedAdmin())
        {
            redirect('admin');
            exit();
        }
	}

	public function img($tipo = false,$id = false, $img = false)
    {

		$this->templates_admin->head();
        $this->templates_admin->header(array('title' => 'Lista de productos'));
        
        $this->templates_admin->sidebar();

		$data['destino'] = $this->input->server('HTTP_REFERER');
		$data['id'] = $id;

		$tiposPermitidos = array('producto', 'slider', 'categorias');

		if(!in_array($tipo, $tiposPermitidos) || $tipo == false)
        {
            echo $tipo;
			//redirect('admin/principal');
			exit();
		}

        $path = 'pics';

		if($tipo == 'producto')
        {
            $object = $this->imgmodel->img($img);

            $data = array(

                'thumb_width'   => $this->config->item('thumb_width'),
                'thumb_height'  => $this->config->item('thumb_height'),
                'tipo'          => 'producto',
                'id'            => $id
            );

            $directorio     = $id;
			$large          = $object->number.'.'.$object->extension;
			$thumb 		    = $object->number.'_thumb.'.$object->extension;
            $referencia     = 'admin/productos/imagenes/'.$id;
            
        }
        elseif($tipo == 'noticias')
        {

            $data = array(

                'thumb_width'   => $this->config->item('news_img_width'),
                'thumb_height'  => $this->config->item('news_img_height'),
                'tipo'          => 'tip',
                'id'            => $id
            );

            $directorio     = 'noticias/'.$id;
            $large          = '01.jpg';
            $thumb          = '02.jpg';
            $referencia     = 'admin/noticias/editar/'.$id;

        }
        elseif($tipo == 'slider')
        {
            $this->load->model('slidermodel');
            $slider = $this->slidermodel->single($id);

            $data = array(

                'thumb_width'   => $this->config->item('slider_width'),
                'thumb_height'  => $this->config->item('slider_height'),
                'tipo'          => 'slide',
                'id'            => $id
            );

            $directorio     = 'slider/'.$id;
            $large          = '01.'.$slider->extension;
            $thumb          = '02.'.$slider->extension;
            $referencia     = 'admin/slider/editar/'.$id;

        }
        elseif($tipo == 'categorias')
        {
            $path = 'img';
            $this->load->model('categoriesmodel');
            $cat = $this->categoriesmodel->single($id);

            $data = array(

                'thumb_width'   => $this->config->item('cat_width'),
                'thumb_height'  => $this->config->item('cat_height'),
                'tipo'          => 'categoria',
                'id'            => $id
            );

            $directorio     = 'categorias/'.$id;
            $large          = '01.jpg';
            $thumb          = '02.jpg';
            $referencia     = 'admin/categorias/editar/'.$id;

        }

        $menu['cancelar'] = base_url().$referencia;

        $this->templates_admin->subMenu($menu, false);
	
		$data['upload_dir'] = "./$path/";			
		$data['upload_path'] = "./$path/".$directorio.'/';
        $data['directorio']	= "$path/" . $directorio;
		$data['large_image_prefix'] = "resize_"; 			
		$data['thumb_image_prefix'] = "thumbnail_";		
		$data['large_image_name'] = $large;
		$data['thumb_image_name'] = $thumb;
		$data['max_file'] = "3"; 							
		$data['max_width'] = "700";
        $thumb2 = "./$path/".$directorio.'/'.$thumb;
        $large = "./$path/".$directorio.'/'.$large;				

		$data['allowed_image_types'] = array('image/pjpeg'=>"jpg",'image/jpeg'=>"jpg",'image/jpg'=>"jpg",'image/png'=>"png",'image/x-png'=>"png",'image/gif'=>"gif");
		$data['allowed_image_ext'] = array_unique($data['allowed_image_types']); 
		$data['image_ext'] = "";	
		foreach ($data['allowed_image_ext'] as $mime_type => $ext)
        {
		    $data['image_ext'].= strtoupper($ext)." ";
		}

		$data['large_image_location'] = $data['upload_path'].$data['large_image_name'];
		$data['thumb_image_location'] = $data['upload_path'].$data['thumb_image_name'];

		if(isset($_POST["upload_thumbnail"]))
        {
			
			$x1 = $_POST["x1"];
			$y1 = $_POST["y1"];
			$x2 = $_POST["x2"];
			$y2 = $_POST["y2"];
			$w = $_POST["w"];
			$h = $_POST["h"];
			
			$scale = $data['thumb_width']/$w;
			if($this->resizeThumbnailImage($thumb2, $large,$w,$h,$x1,$y1,$scale))
            {
                redirect($referencia);
                exit();
            }
		  
		}

		$data['current_large_image_width'] = $this->getWidth($data['large_image_location']);
		$data['current_large_image_height'] = $this->getHeight($data['large_image_location']);

		$this->load->view('admin/edicion/edicion', $data);

        $array['extra'] = $this->load->view('admin/edicion/funciones', false, true);

        $this->templates_admin->footer($array);
    }

    public function resizeImage($image,$width,$height,$scale)
    {

    	list($imagewidth, $imageheight, $imageType) = getimagesize($image);
    	$imageType = image_type_to_mime_type($imageType);
    	$newImageWidth = ceil($width * $scale);
    	$newImageHeight = ceil($height * $scale);
    	$newImage = imagecreatetruecolor($newImageWidth,$newImageHeight);
    	switch($imageType) {
    		case "image/gif":
    		$source=imagecreatefromgif($image); 
    		break;
    		case "image/pjpeg":
    		case "image/jpeg":
    		case "image/jpg":
    		$source=imagecreatefromjpeg($image); 
    		break;
    		case "image/png":
    		case "image/x-png":
    		$source=imagecreatefrompng($image); 
    		break;
    	}
    	imagecopyresampled($newImage,$source,0,0,0,0,$newImageWidth,$newImageHeight,$width,$height);

    	switch($imageType) {
    		case "image/gif":
    		imagegif($newImage,$image); 
    		break;
    		case "image/pjpeg":
    		case "image/jpeg":
    		case "image/jpg":
    		imagejpeg($newImage,$image,90); 
    		break;
    		case "image/png":
    		case "image/x-png":
    		imagepng($newImage,$image);  
    		break;
    	}

    	chmod($image, 0777);
    	return $image;
    }

    public function resizeThumbnailImage($thumb_image_name, $image, $width, $height, $start_width, $start_height, $scale){
    	list($imagewidth, $imageheight, $imageType) = getimagesize($image);
    	$imageType = image_type_to_mime_type($imageType);

    	$newImageWidth = ceil($width * $scale);
    	$newImageHeight = ceil($height * $scale);
    	
    	switch($imageType) {
    		case "image/gif":
    		$source=imagecreatefromgif($image); 
    		break;
    		case "image/pjpeg":
    		case "image/jpeg":
    		case "image/jpg":
    		$source=imagecreatefromjpeg($image); 
    		break;
    		case "image/png":
    		case "image/x-png":
    		$source=imagecreatefrompng($image); 
    		break;
    	}


        $newImage = imagecreatetruecolor($newImageWidth,$newImageHeight);

        imagealphablending($newImage, true);

        $transparent = imagecolorallocatealpha( $newImage, 0, 0, 0, 127 ); 
        imagefill($newImage, 0, 0, $transparent); 

    	imagecopyresampled($newImage,$source,0,0,$start_width,$start_height,$newImageWidth,$newImageHeight,$width,$height);

        imagealphablending($newImage, false); 

        // save the alpha 
        imagesavealpha($newImage,true); 

    	switch($imageType) {
    		case "image/gif":
    		imagegif($newImage,$thumb_image_name); 
    		break;
    		case "image/pjpeg":
    		case "image/jpeg":
    		case "image/jpg":
    		imagejpeg($newImage,$thumb_image_name,90); 
    		break;
    		case "image/png":
    		case "image/x-png":
    		imagepng($newImage,$thumb_image_name);  
    		break;
    	}
    	//chmod($thumb_image_name, 0777);
    	return $thumb_image_name;
    }

    public function getHeight($image) {
    	$size = getimagesize($image);
    	$height = $size[1];
    	return $height;
    }

    public function getWidth($image) {
    	$size = getimagesize($image);
    	$width = $size[0];
    	return $width;
    }



    

}
?>