<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Faqs extends CI_Controller{


    public function __construct()
    {
        parent::__construct();

        $this->load->model('settingsmodel');
        $this->load->model('statusmodel');
        $this->load->model('faqsmodel');

        $this->session->set_userdata('admin_menu', 'faqs');

        if( ! $this->statusmodel->loggedAdmin())
        {
            redirect('admin');
            exit();
        }
    }

    public function index()
    {
        $this->templates_admin->head();
        $this->templates_admin->header(array('title' => 'Lista de Preguntas frecuentes'));
        $this->templates_admin->sidebar();
        $this->templates_admin->subMenu(array(), false, true, 'faqs');
        
        $data = array(

            'faqs'    => $this->faqsmodel->get(0, 90000, 'faqs.order ASC', false),

        );

        $this->load->view('admin/faqs/listar', $data);

        $this->templates_admin->footer();
    }

    public function nuevo()
    {

        $data = array(

            'id'            => null,
            'pregunta'      => html_escape( $this->input->post('pregunta', true) ),
            'respuesta'     => html_escape( $this->input->post('respuesta', true) ),
            'order'         => 99999,
            'activo'        => 1,
        );

        if( $this->faqsmodel->add($data) )
        {
            redirect('admin/faqs');
        }
        else
        {
            die('Se ha producido un error.');
        }

    }

    public function actualizar()
    {
        //var_dump($_POST);

        if( !empty($_POST) )
        {
            foreach ($_POST['id'] as $key => $id)
            {
                $data = array(

                    'pregunta'        => html_escape( $_POST['pregunta'][$key] ),
                    'respuesta'       => html_escape( $_POST['respuesta'][$key] ),
                    'activo'          => isset( $_POST['activo'][$key] ) ? 1 : 0
                );

                $this->faqsmodel->update($id, $data);

            }
        }

        redirect('admin/faqs');
    }

    public function eliminar($id = false)
    {   

        if( !$id ) die();

        $this->faqsmodel->delete($id);

        redirect('admin/faqs');
    }

}
?>