<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Main extends CI_Controller{

	public function __construct()
	{
	   	parent::__construct();
	 
	   	$this->load->model('settingsmodel');
	   	$this->load->model('statusmodel');
	   	$this->load->model('adminmodel');
	   	$this->load->model('productsmodel');
	   	$this->load->model('searchmodel');

	   	$this->session->set_userdata('admin_menu', 'main');
	   	
        if( ! $this->statusmodel->loggedAdmin())
        {
            #no esta logueado, redirijo
            redirect('admin');
        }
        
	}

	public function index()
	{

		$this->templates_admin->head();
		$this->templates_admin->header(array('title' => 'Principal'));
		$this->templates_admin->sidebar();

		$data = array(

			'cantidad_productos' 	=> $this->productsmodel->count(),
			'productos'				=> $this->productsmodel->get(0, 12),
			'busquedas'				=> $this->searchmodel->keywords(),
		);

		$this->load->view('admin/main', $data);

		$this->templates_admin->footer();
	}

	public function set_dolar()
	{
		$valor_dolar_promedio = $this->input->post('valor_dolar_promedio');

		if($valor_dolar_promedio == '' || $valor_dolar_promedio == 0)
		{
			$valor_dolar_promedio = 1;
		}

		$this->settingsmodel->edit('valor_dolar_promedio', $valor_dolar_promedio );
	}


	public function config()
	{
		
	}

	public function datos()
	{
		$data['success'] = false;

		if(isset($_POST['enviar']))
		{
			if($this->form_validation->run('data_admin') == true)
			{	
				$admin = $this->adminmodel->single( $this->session->userdata('id_admin') );
				$data = array(

					'name' 			=> $this->input->post('name'),
					'lastname' 		=> $this->input->post('lastname'),
					'pass' 			=> $this->input->post('password') != '' ? md5( $this->input->post('password') ) : $admin->pass,
					'mail'			=> $this->input->post('mail')

				);

				if($this->adminmodel->update($data))
				{
					unset($data);
					$data['success'] = true;
				}
			}
			
		}


		$this->templates_admin->head();
		$this->templates_admin->header(array('title' => 'Mis Datos'));

		$data['admin'] = $this->adminmodel->single( $this->session->userdata('id_admin') );

		$this->load->view('admin/datos', $data);

		$this->templates_admin->footer();
	}


	public function resultados()
	{
		if(isset($_POST['personalizar']))
		{
			$data = array(
					
				'resultados' 	=> $this->input->post('resultados'),
				'categoria'		=> $this->input->post('categoria'),
			);

			$this->session->set_userdata($data);
			
			redirect(base_url('admin/productos/listar'));
		}
		
		show_404();
	}

	public function delete_keywords()
	{
		$this->searchmodel->delete_keywords();
		redirect('admin/principal');
	}

	public function logout()
	{
		$this->session->sess_destroy();
		redirect( base_url() );
	}

	
	
}