<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Noticias extends CI_Controller{

    private $tipo = "noticias";
    private $response;

    public function __construct()
    {
        parent::__construct();

        $this->load->model('settingsmodel');
        $this->load->model('statusmodel');
        $this->load->model('newsmodel');
        $this->load->library('upload');
        $this->session->set_userdata('admin_menu', 'news');

        if( ! $this->statusmodel->loggedAdmin())
        {
            redirect('admin');
            exit();
        }

        $this->response             = new stdClass();
        $this->response->success    = false;
        $this->response->text       = '';
    }

    public function listar()
    {
        $this->templates_admin->head();
        $this->templates_admin->header(array('title' => 'Lista de noticias'));
        $this->templates_admin->sidebar();
        $this->templates_admin->subMenu(array('nuevo+' => 'noticias/nuevo', 'Categorias' => 'noticias/ver_categorias'), false, true, $this->tipo);

        $data[$this->tipo]  = $this->newsmodel->get();
        $data['tipo']       = $this->tipo;

        $this->load->view('admin/noticias/list', $data);

        $this->templates_admin->footer( array('editor' => true) );
    }

    public function nuevo()
    {
        $this->templates_admin->head();
        $this->templates_admin->header(array('title' => 'Nueva Noticia'));
        $data = array(  

                'tipo'          => $this->tipo,
                'added'         => false,
                'categories'    => $this->newsmodel->getCategories(true),
            );
        
        if(isset($_POST['enviar']))
        {
            if($this->form_validation->run('news'))
            {
                if($this->upload())
                {
                    if($this->insert())
                    {
                        $data['added'] = true;
                    }
                    else
                    {
                        $data['msj']   = "Error al crear slide";
                    }
                }
                else
                {
                    $data['error'] = array('error' => $this->upload->display_errors());
                }

            }
        }

        $accion = $data['added'] ? 'volver' : 'cancelar';
        $this->templates_admin->sidebar();
        $this->templates_admin->subMenu(array($accion => 'noticias/listar' ));

        $this->load->view('admin/noticias/nuevo', $data);
        
        $this->templates_admin->footer();
    }

    public function editar($id)
    {
        $this->templates_admin->head();
        $this->templates_admin->header(array('title' => 'Editar Noticia'));

        $data = array(

            'tipo'          => $this->tipo,
            'noticia'       => $this->newsmodel->single($id),
            'added'         => false,
            'categories'    => $this->newsmodel->getCategories(true),
        );
        
        if(isset($_POST['enviar']))
        {
            if($this->form_validation->run('news'))
            {
                $array = array(

                    'title'         => $this->input->post('title'),
                    'text'          => $this->input->post('text')
                );

                if($this->upload())
                {
                    if($this->update($id))
                    {
              
                        redirect('admin/noticias/listar');
                    }
                    
                }
                
            }
        }

        if(file_exists('./pics/'.$this->tipo.'/'.$id.'/01.jpg'))
        {
            $data['foto'] = base_url().'pics/'.$this->tipo.'/'.$id.'/02.jpg';
        }
        else
        {
            $data['foto'] = false;
        }

        $this->templates_admin->sidebar();
        $this->templates_admin->subMenu(array('cancelar' => 'noticias/listar' ));

        $this->load->view('admin/noticias/edit', $data);
        
        $this->templates_admin->footer();
    
        $accion = $data['added'] ? 'volver' : 'cancelar';
        
        $this->templates_admin->footer();
    }

  

    private function upload()
    {
        if( ! file_exists('./pics/'.$this->tipo))
        {
            mkdir('./pics/'.$this->tipo);
            chmod('./pics/'.$this->tipo, 0644);
        }

        if(isset($_FILES['userfile']))
        {
            if($_FILES['userfile']['name'] != '')
            {
                $ext = pathinfo($_FILES['userfile']['name'], PATHINFO_EXTENSION);

                if(file_exists('./pics/'.$this->tipo.'/temp.'.$ext))
                {
                    unlink('./pics/'.$this->tipo.'/temp.'.$ext);
                }

                $config['upload_path'] = './pics/'.$this->tipo.'/';
                $config['file_name'] = 'temp.'.$ext;
                $config['allowed_types'] = 'jpg';
                $config['max_size'] = '2000';
                $this->upload->initialize($config);
                
                if( ! $this->upload->do_upload())
                {
                    return false;
                }
                else
                {
                    $this->ext_temp = $ext;
                    return true;
                }        
            }
        }

        return true;
    }

    private function insert($update = false)
    {

        $array = array(

            'id'            => null,
            'title'         => $this->input->post('title'),
            'text'          => $this->input->post('text'),
            'date'          => date('Y-m-d H:i:s'),
            'video'         => $this->input->post('video'),
            'category'      => $this->input->post('category'),
            'order'         => 0,
            'active'        => 1
        );

        if($this->newsmodel->add($array))
        {
            $id = $this->newsmodel->last();

            if(mkdir('./pics/'.$this->tipo.'/'.$id, 0755))
            {
                if(@$_FILES['userfile']['name'] != '')
                {
                    if(file_exists('./pics/'.$this->tipo.'/temp.jpg'))
                    {
                        if(copy('./pics/'.$this->tipo.'/temp.jpg', './pics/'.$this->tipo.'/'.$id.'/temp.jpg'))
                        {
                            rename('./pics/'.$this->tipo.'/'.$id.'/temp.jpg','./pics/'.$this->tipo.'/'.$id.'/01.jpg');
                            copy('./pics/'.$this->tipo.'/'.$id.'/01.jpg', './pics/'.$this->tipo.'/'.$id.'/02.jpg');
                            unlink('./pics/'.$this->tipo.'/temp.jpg');
                            return true;
                        }
                    }
                }
                else
                {
                    return true;
                }
            }
        }

        return false;
    }

    private function update($id)
    {

        $array = array(

            'title'             => $this->input->post('title'),
            'text'              => $this->input->post('text'),
            'video'             => $this->input->post('video'),
            'category'          => $this->input->post('category'),

        );


        if($this->newsmodel->update($id, $array))
        {
            
            if(isset($_FILES['userfile']))
            {
                if($_FILES['userfile']['name'] != '')
                {

                    if( ! file_exists('./pics/'.$this->tipo.'/'.$id) )
                    {
                        mkdir('./pics/'.$this->tipo.'/'.$id);
                    }

                    if(copy('./pics/'.$this->tipo.'/temp.jpg', './pics/'.$this->tipo.'/'.$id.'/temp.jpg'))
                    {
                        rename('./pics/'.$this->tipo.'/'.$id.'/temp.jpg','./pics/'.$this->tipo.'/'.$id.'/01.jpg');
                        copy('./pics/'.$this->tipo.'/'.$id.'/01.jpg', './pics/'.$this->tipo.'/'.$id.'/02.jpg');
                        unlink('./pics/'.$this->tipo.'/temp.jpg');
                        return true;
                    }

                }

                return true;

            }


            return true;
        }

        return false;
    }

    public function nueva_categoria()
    {
        $this->load->model('newscatmodel');

        $this->templates_admin->head();
        $this->templates_admin->header(array('title' => 'Nueva Categoria'));
       
        $data = array(  

            'tipo'          => $this->tipo,
            'added'         => false
        );
        
        if(isset($_POST['enviar']))
        {
            if($this->form_validation->run('news_category'))
            {
               
                $data = array(

                    'id'            => null,
                    'title'         => $this->input->post('title'), 
                    'slug'          => url_title($this->input->post('title'), '-', true),
                    'active'        => 1
                );


                if($this->newscatmodel->addCategory($data))
                {
                    $data['added'] = true;
                }
                else
                {
                    $data['msj']   = "Error al crear la categoria";
                }             
                

            }
        }

        $accion = $data['added'] ? 'volver' : 'cancelar';

        $this->templates_admin->sidebar();
        $this->templates_admin->subMenu(array($accion => 'noticias/listar'));

        $this->load->view('admin/noticias/nueva_categoria', $data);
        
        $this->templates_admin->footer();
    }

    public function ver_categorias()
    {
        $this->load->model('newscatmodel');

        $this->templates_admin->head();
        $this->templates_admin->header(array('title' => 'Categorias de Noticias'));

        $this->templates_admin->sidebar();
        $this->templates_admin->subMenu(array( 'Volver' => 'noticias/listar'), false, true, 'cat_noticias');
        $data['msj'] = "";
        $confirmar = false;

        $data['categorias']  = $this->newscatmodel->getCategories();
        $data['tipo']       = $this->tipo;

        $this->load->view('admin/noticias/list_categorias', $data);

        $this->templates_admin->footer();
    }

    public function editar_categoria($id)
    {   
        $this->load->model('newscatmodel');
        $this->templates_admin->head();
        $this->templates_admin->header(array('title' => 'Nueva Categoria'));
        $data = array(  

                'tipo'          => $this->tipo,
                'added'         => false,
                'categoria'     => $this->newscatmodel->singleCategory($id)
            );
        
        if(isset($_POST['enviar']))
        {
            if($this->form_validation->run('news_category'))
            {
               
                $data = array(

                    'title'         => $this->input->post('title'),
                    'slug'          => url_title($this->input->post('title'), '-', true),
                    'active'        => 1
                
                );

                if($this->newscatmodel->updateCategory($id, $data))
                {
                    $data['added'] = true;
                }
                else
                {
                    $data['msj']   = "Error al editar la categoria";
                }             
                

            }
        }

        $accion = $data['added'] ? 'volver' : 'cancelar';

        $this->templates_admin->sidebar();
        $this->templates_admin->subMenu(array($accion => 'noticias/listar'));

        $this->load->view('admin/noticias/editar_categoria', $data);
        
        $this->templates_admin->footer();
    }

    public function eliminar_foto($id = false)
    {
        if($id != false)
        {
            if(file_exists('./img/'.$this->tipo.'/'.$id.'/01.jpg'))
            {
                unlink('./img/'.$this->tipo.'/'.$id.'/01.jpg');
            }

            if(file_exists('./img/'.$this->tipo.'/'.$id.'/02.jpg'))
            {
                unlink('./img/'.$this->tipo.'/'.$id.'/02.jpg');
            }

            redirect('admin/'.$this->tipo.'/editar/'.$id);

        }
        else
        {
            redirect(base_url());
        }
    }

    public function masivo($action)
    {
       // setActive($id, $active = false)
        $items = $this->input->post('items');

        $type = $this->input->post('type');

        if($type == 'categorias')
        {
            $model = 'newscatmodel';
        }
        elseif($type == 'noticias')
        {
            $model = 'newsmodel';
        }
        else
        {
            die('error');
        }

        $this->load->model($model, 'modelo');
        

        if( !is_array($items) )
        {
            echo json_encode($this->response);
            die();
        }

        switch ($action)
        {
            case 'activar':
                
                foreach($items as $key => $id)
                {
                    $this->modelo->setActive($id, true);
                }
                $this->response->success = true;
                echo json_encode($this->response);
                die();

            break;
            
            case 'desactivar':
                
                foreach($items as $key => $id)
                {
                    $this->modelo->setActive($id, false);
                }
                $this->response->success = true;
                echo json_encode($this->response);
                die();

            break;

            case 'eliminar':
                
                foreach($items as $key => $id)
                {
                    $this->modelo->delete($id);
                }
                $this->response->success = true;
                echo json_encode($this->response);
                die();

            break;

            default:
                    
            break;
        }


        echo json_encode($this->response);
    }


}