<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Ofertas extends CI_Controller{


    public function __construct()
    {
        parent::__construct();

        $this->load->model('settingsmodel');
        $this->load->model('statusmodel');
        $this->load->model('ofertasmodelo');

        $this->session->set_userdata('admin_menu', 'ofertas');

        if( ! $this->statusmodel->loggedAdmin())
        {
            redirect('admin');
            exit();
        }
    }

    public function index()
    {
        $nuevo = $this->nuevo();

        $this->templates_admin->head();
        $this->templates_admin->header(array('title' => 'Lista de ofertas'));
        $this->templates_admin->sidebar();
        $this->templates_admin->subMenu(array(), false, true, 'metodos');
    

        $data = array(

            'nuevo'      => isset($nuevo) ? $nuevo : false,
            'ofertas'    => $this->ofertasmodelo->get(0, 90000, 'fecha DESC', false),

        );

        $this->load->view('admin/ofertas/listar', $data);

        $this->templates_admin->footer();
    }

    public function nuevo()
    {

        if( ! isset($_POST['fecha']) ) return false;

        $error = false;
        $data = false;

        $config['upload_path']          = './pics/ofertas/';
        $config['file_name']            = url_title( $_FILES['userfile']['name'] , true, '-');
        $config['allowed_types']        = 'jpg';
        $config['max_size']             = 2000;

        $this->load->library('upload', $config);

        if ( !$this->upload->do_upload('userfile') )
        {
            return $this->upload->display_errors();
        }
        else 
        {
            $data = array( 'upload_data' => $this->upload->data() );

            $datos = array(

                'id'            => null,
                'titulo'        => html_escape( $this->input->post('titulo', true) ),    
                'fecha'         => html_escape( $this->input->post('fecha', true) ),
                'url'           => 'pics/ofertas/' . $data['upload_data']['file_name'] ,
                'activo'        => 0
            );


            if( $this->ofertasmodelo->add($datos) )
            {
               redirect('admin/ofertas');
            }
            else
            {
                return $error;
            }

        }

    }

    public function activar($id = false)
    {
        if( !$id ) die();

        $id = intval($id);

        $single = $this->ofertasmodelo->single($id);

        $a = $single->activo;

        // $this->ofertasmodelo->desactivar_todo();

        $this->ofertasmodelo->set_active($id, !$a);

        redirect( $this->input->server('HTTP_REFERER') );
    }

    public function eliminar($id = false)
    {
        if( !$id ) die();

        $id = intval($id);

        $single = $this->ofertasmodelo->single($id);

        $this->ofertasmodelo->delete($id);

        unlink('./' . $single->url);

        redirect( $this->input->server('HTTP_REFERER') );
    }

    public function actualizar()
    {
        //var_dump($_POST);

        if( !empty($_POST) )
        {
            foreach ($_POST['id_metodo'] as $key => $id)
            {
                $data = array(

                    'nombre'        => html_escape( $_POST['nombre'][$key] ),
                    'descripcion'   => html_escape( $_POST['descripcion'][$key] ),
                    'activo'        => isset( $_POST['activo'][$key] ) ? 1 : 0
                );

                $this->metodosmodelo->update($id, $data);

            }
        }

        redirect('admin/metodos');
    }



}
?>