<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Orders extends CI_Controller{

	private $tipo = "pedidos";

	public function __construct()
	{
	   	parent::__construct();

	   	$this->load->model('settingsmodel');
	   	$this->load->model('statusmodel');
        $this->load->model('ordersmodel');

        $this->session->set_userdata('admin_menu', 'orders');

        if( ! $this->statusmodel->loggedAdmin())
        {
            redirect('admin');
            exit();
        }
    }

	public function listar()
	{
		$this->templates_admin->head();
		$this->templates_admin->header(array('title' => 'Lista'));
        $this->templates_admin->sidebar();
        $this->templates_admin->subMenu(array('volver' => '' ), false, false, 'pedidos');

        $data['msj'] = "";
        $confirmar = false;

		$data[$this->tipo] 	= $this->ordersmodel->get();
		$data['tipo']		= $this->tipo;

        $this->load->view('admin/'.$this->tipo.'/list', $data);

		$this->templates_admin->footer();
	}

    public function ver($id = false)
    {
        if(!$id) show_404();

        $pedido = $this->ordersmodel->single($id);

        $this->templates_admin->head();
        $this->templates_admin->header(array('title' => 'Pedido'));
        $this->templates_admin->sidebar();
        $this->templates_admin->subMenu(array('volver' => 'pedidos/listar' ));

        $data['pedido']  = $this->ordersmodel->single($id);

        $this->load->view('admin/'.$this->tipo.'/ver', $data);

        $this->templates_admin->footer();

    }

    public function acciones()
    {

        $accion = $this->input->post('accion', true);
        $id     = $this->input->post('id', true);

        /*
        pagado" "rechazado cliente" rechazado LG" "entregado" y "pendiente"
        */
        $tipos = array(

            'Pago',
            'Rechazado Cliente',
            'Rechazado Empresa',
            'Entregado',
            'Pendiente',
			'Facturado',
        );

        if(!$accion || !$id) redirect('admin/pedidos/listar');

        if( !in_array($accion, $tipos) && $accion != 'eliminar' ) redirect('admin/pedidos/listar');

        $pedido = $this->ordersmodel->single($id);

        $data = array();

        $data['status'] = $accion;

        $this->ordersmodel->update($id, $data);

        redirect('admin/pedidos/listar');

    }





}
