<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Slider extends CI_Controller{

    private $tipo = "slider";
    private $ext_temp = false;

    public function __construct()
    {
        parent::__construct();

        $this->load->model('settingsmodel');
        $this->load->model('statusmodel');
        $this->load->model('slidermodel');
        $this->load->library('upload');
        $this->session->set_userdata('admin_menu', 'slider');
        $this->ext_temp = false;
        if( ! $this->statusmodel->loggedAdmin())
        {
            redirect('admin');
            exit();
        }
    }

    public function listar()
    {
        $this->templates_admin->head();
        $this->templates_admin->header(array('title' => 'Lista de slides'));
        $this->templates_admin->sidebar();
        $this->templates_admin->subMenu(array('nuevo slide+' => 'slider/nuevo'), false, true, 'slider');

        $data['msj'] = "";
        $confirmar = false;
        
        $data[$this->tipo]  = $this->slidermodel->get();
        $data['tipo']       = $this->tipo;
        $this->load->view('admin/'.$this->tipo.'/list', $data);
        $this->templates_admin->footer();
    }

    public function nuevo()
    {
        
        $this->templates_admin->head();
        $this->templates_admin->header(array('title' => 'Nuevo Slide'));
        $data = array(  

                'tipo'          => $this->tipo,
                'error'         => "",
                'msj'           => "",
                'added'         => false
            );
        
        if(isset($_POST["enviar"]))
        {

            if($this->form_validation->run($this->tipo))
            {
                
                if($this->upload())
                {
                    if($this->insert())
                    {
                        $data['added'] = true;
                    }
                    else
                    {
                        $data['msj']    = "Error al crear slide";
                    }
                }
                else
                {
                    $data['error'] = array('error' => $this->upload->display_errors());
                }

            }
        }

        $accion = $data['added'] ? 'volver' : 'cancelar';

        $this->templates_admin->sidebar();
        $this->templates_admin->subMenu(array($accion => 'slider/listar' ));

        $this->load->view('admin/'.$this->tipo.'/nuevo', $data); 
            
        $this->templates_admin->footer();
    }

    public function editar($id)
    {

        $this->templates_admin->head();
        $this->templates_admin->header(array('title' => 'Nuevo Slide'));
        $this->templates_admin->sidebar();

        $data['msj']        = "";
        $data['error']      = "";
        $data['tipo']       = $this->tipo;

        if(isset($_POST["enviar"]))
        {

            if($this->form_validation->run($this->tipo))
            {

                if($this->upload())
                {
                    if($this->update($id))
                    {
                        redirect('admin/'.$this->tipo.'/listar');
                    }
                    else
                    {
                        $data['msj']    = "Error al editar slide";
                    }
                }
                else
                {
                    $data['error'] = $this->upload->display_errors();
                }
            }
        }

        $data[$this->tipo]     = $this->slidermodel->single($id);

        if(file_exists('./pics/'.$this->tipo.'/'.$id.'/01.'.$data[$this->tipo]->extension))
        {
            $data['foto'] = base_url().'pics/'.$this->tipo.'/'.$id.'/02.'.$data[$this->tipo]->extension;
        }
        else
        {
            $data['foto'] = false;
        }
    
        $this->templates_admin->subMenu(array('cancelar' => 'slider/listar' ));

        $this->load->view('admin/'.$this->tipo.'/edit', $data); 
            
        $this->templates_admin->footer();
    }

    public function eliminar_foto($id = false)
    {

        if($id != false)
        {
            $slider = $this->slidermodel->single($id);

            if(file_exists('./pics/'.$this->tipo.'/'.$id.'/01.'.$slider->extension))
            {
                unlink('./pics/'.$this->tipo.'/'.$id.'/01.'.$slider->extension);
            }

            if(file_exists('./pics/'.$this->tipo.'/'.$id.'/02.'.$slider->extension))
            {
                unlink('./pics/'.$this->tipo.'/'.$id.'/02.'.$slider->extension);
            }

            redirect('admin/'.$this->tipo.'/editar/'.$id);

        }
        else
        {
            redirect(base_url());
        }
    }

    private function upload()
    {
  
        if( ! file_exists('./pics/'.$this->tipo))
        {
            mkdir('./pics/'.$this->tipo);
            chmod('./pics/'.$this->tipo, 0755);
        }

        if(isset($_FILES['userfile']))
        {

            if($_FILES['userfile']['name'] != '')
            {

                $ext = pathinfo($_FILES['userfile']['name'], PATHINFO_EXTENSION);

                if(file_exists('./pics/'.$this->tipo.'temp.'.$ext))
                {
                    unlink('./pics/'.$this->tipo.'/temp.'.$ext);
                }

                $config['upload_path'] = './pics/'.$this->tipo.'/';
                $config['file_name'] = 'temp.'.$ext;
                $config['allowed_types'] = 'jpg|png';
                $config['max_size'] = '2000';
                $this->upload->initialize($config);
                
                if( ! $this->upload->do_upload())
                {

                    return false;
                }
                else
                {
                    $this->ext_temp = $ext;
                    return true;
                }        
            }
        }

        return true;
    }

    private function insert($update = false)
    {

        $array = array(

            'id'        => null,
            'title'     => $this->input->post('title'),
            'text'      => $this->input->post('text'),
            'link'      => $this->input->post('link'),
            'order'     => 1,
            'extension' => $this->ext_temp,
            'type'      => 'slide',
            'active'    => 1 
        );

        if($this->slidermodel->add($array))
        {
            $id = $this->slidermodel->last();

            if(mkdir('./pics/'.$this->tipo.'/'.$id, 0755))
            {
                if(file_exists('./pics/'.$this->tipo.'/temp.'.$this->ext_temp))
                {
                    if(copy('./pics/'.$this->tipo.'/temp.'.$this->ext_temp, './pics/'.$this->tipo.'/'.$id.'/temp.'.$this->ext_temp))
                    {
                        rename('./pics/'.$this->tipo.'/'.$id.'/temp.'.$this->ext_temp,'./pics/'.$this->tipo.'/'.$id.'/01.'.$this->ext_temp);
                        copy('./pics/'.$this->tipo.'/'.$id.'/01.'.$this->ext_temp, './pics/'.$this->tipo.'/'.$id.'/02.'.$this->ext_temp);
                        unlink('./pics/'.$this->tipo.'/temp.'.$this->ext_temp);
                        return true;
                    }
                }
            }
        }

        return false;
    }

    private function update($id)
    {
        $slider = $this->slidermodel->single($id);

        $array = array(

            'title'     => $this->input->post('title'),
            'text'      => $this->input->post('text'),
            'link'      => $this->input->post('link'),
            'order'     => $slider->order,
            'active'    => $slider->active,
            'type'      => 'slide',
        );

        if($this->slidermodel->update($slider->id, $array))
        {

            if(isset($_FILES['userfile']))
            {
                if($_FILES['userfile']['name'] != '')
                {

                    if(copy('./pics/'.$this->tipo.'/temp.'.$slider->extension, './pics/'.$this->tipo.'/'.$id.'/temp.'.$slider->extension))
                    {
                        rename('./pics/'.$this->tipo.'/'.$id.'/temp.'.$slider->extension,'./pics/'.$this->tipo.'/'.$id.'/01.'.$slider->extension);
                        copy('./pics/'.$this->tipo.'/'.$id.'/01.'.$slider->extension, './pics/'.$this->tipo.'/'.$id.'/02.'.$slider->extension);
                        unlink('./pics/'.$this->tipo.'/temp.'.$slider->extension);
                        return true;
                    }
                }
                return true;

            }
            return true;
        }

        return false;
    }

    /////////////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////SECCION DE FUNCIONES//////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////////////////


      

    
    
    public function eliminar($id = null){
        
        if($id == false || !is_numeric($id)){

            redirect('admin/paginas/listar');
            exit();
        }
        
        $data['permisos']   = $this->permisos;
        $data['error']      = false;
        $data['titulo']     = ' | <span>Eliminar Pagina</span>';
        $this->load->view('admin/header',$data);

        $menu = array(
            'crear' => false,
            'paginador' => false,
            'cancelar' => false,
            'ordenar' => false
            );

        $this->load->view('admin/paginas/menu',$menu);
        
        //elimino el producto
        if($id != null){
            
            if($this->productosmodelo->eliminar_producto($id)){
                
                $this->load->view('admin/paginas/eliminar_exito');
            
            }else{
                
            }
            
        }else{
            
            show_404();
        }

        //cargo footer
        $this->load->view('admin/footer.php');
    }


    














}
?>