<?php

Class Functions{

	private $CI;

	public function __construct()
	{
		$this->CI =& get_instance();
        $this->CI->load->model('categoriesmodel');
	}

    public function total($type = 'PES')
    {
        $result = 0;

        $response = new stdClass();
        $response->formateado = '';
        $response->total = '';

        if( $this->CI->cart->total_items() > 0 )
        {
            foreach($this->CI->cart->contents() as $key => $value)
            {
                if( $value['currency'] == $type )
                {
                    $result += $value['subtotal'];
                }

            }
        }
        else
        {
            $result = 0;
        }

        $r = $this->CI->cart->format_number($result);

        $response->formateado = $type == 'PES' ? '$ '.$r : 'U$S '.$r;
        $response->total = $result;

        return $response;
    }

    /*
    Metodo para calcular el total final de la compra, incluyendo gastos de envio
    Solo si es en pesos sumo el envio
    */

    public function totalFinal($type = 'PES')
    {
        $response = new stdClass();
        $response->formateado = '';
        $response->total = '';

        $parcial = intval( $this->total($type)->total );

        $costos_envio = 0;

        if( $type == 'PES' )
        {
            $costos_envio = $this->totalEnvio()->total;
        }

        $response->total = $parcial + $costos_envio;

        $r = $this->CI->cart->format_number($response->total);

        $response->formateado = $type == 'PES' ? '$ '.$r : 'U$S '.$r;

        return $response;

    }

    public function totalEnvio()
    {
        $response = new stdClass();
        $response->formateado = 'Se coordinara con su ejecutivo de ventas al finalizar la compra';
        $response->total = 0;

        if( $this->CI->session->userdata('CARRITO_tipo_envio') != 'Envio a domicilio' )
        {
            return $response;
        }

        foreach($this->CI->cart->contents() as $key => $value)
        {
            //Si entro aca anulo el costo de envio
            if( $value['nulo'] )
            {
                $response->total = 0;
                return $response;
            }

        }

        if( $this->CI->session->userdata('CARRITO_departamento') != 'Montevideo' )
        {
            foreach($this->CI->cart->contents() as $key => $value)
            {
                $single     = $this->CI->productsmodel->single( $value['id'] );

                if( $single->cart->bulto )
                {
                    $bulto             = $this->CI->bultosmodelo->single( $single->cart->bulto );
                    $response->total  += round( intval($bulto->precio * $single->cart->cantidad_bultos ) );
                }

            }
        }
        else
        {
            $especial = 0;

            if( $this->CI->cart->total_items() == 1 )
            {
                foreach( $this->CI->cart->contents() as $k => $v )
                {
                    $especial = $v['especial'];
                }
            }

            if( $especial )
            {
                $response->total = $this->CI->settings->get('precio_envio_especial');
            }
            else
            {
                $response->total = $this->CI->settings->get('precio_'.$this->CI->session->userdata('CARRITO_zona') );
            }
        }

        if( $this->CI->session->userdata('CARRITO_departamento') == 'San Jose' || $this->CI->session->userdata('CARRITO_departamento') == 'Canelones' )
        {
            $response->total = 0;
        }
        else
        {
            $r = $this->CI->cart->format_number($response->total);

            $response->formateado = '$ '.$r;
        }

        return $response;
    }

    public function precioCart($cart)
    {
        if(!is_array($cart)) return 'Error';

        if($cart['currency'] == 'DOL')
        {
            return 'U$S ' . $this->CI->cart->format_number($cart['subtotal']);
        }

        return '$ ' . $this->CI->cart->format_number($cart['subtotal']);
    }

    public function precioUnitarioCart($cart)
    {
        if(!is_array($cart)) return 'Error';

        if($cart['currency'] == 'DOL')
        {
            return 'U$S ' . $this->CI->cart->format_number($cart['price']);
        }

        return '$ ' . $this->CI->cart->format_number($cart['price']);
    }

    public function precio($cart = false)
    {
        if(!is_object($cart)) return 'Error';

        if( !intval($cart->price) )
        {
            return 'Solicitar Presupuesto';
        }

        if($cart->currency == 'DOL')
        {
            return 'U$S ' . $this->CI->cart->format_number($cart->price);
        }

        return '$ ' . $this->CI->cart->format_number($cart->price);
    }

    public function precioFinal($cart)
    {
        if(!is_object($cart)) return 'Error';

        $factor = $cart->discount / 100;

        $precio = $cart->price;

        $descuento = $precio * $factor;

        $final = round( $precio - $descuento );

        if($cart->currency == 'DOL')
        {
            return 'U$S ' . $this->CI->cart->format_number( $final );
        }

        return '$ ' . $this->CI->cart->format_number( $final );
    }

    public function checkUserData()
    {
        if($this->CI->session->userdata('logged_user') == true)
        {
            if($this->CI->session->userdata('name_user') == '' || $this->CI->session->userdata('lastname_user') == '' )
            {
                return false;
            }

            return true;
        }

        return true;
    }

    public function checkCartData()
    {
        if($this->CI->session->userdata('logged_user') == true)
        {
            $user = $this->CI->usersmodel->single( $this->CI->session->userdata('id_user') );

            if( !$user ) return false;

            if($user->name == '' || $user->lastname == '' || $user->mail == '' || $user->address == '' || $user->tel == '')
            {
                return false;
            }

            return true;
        }

        return false;
    }

    public function setUrlReferer()
    {

        $path = uri_string();

        $test = explode('/', $path);

        if( count($test) > 1 )
        {
            $url = $test[0];
        }
        else
        {
            $url = $path;
        }

        $this->CI->session->set_userdata('url_referer', $url);
    }

    public function getUrlReferer()
    {
        return $this->CI->session->userdata('url_referer');
    }

    public function tiempoTranscurrido($datetime)
    {
        date_default_timezone_set('America/Montevideo');

        $actual = time();

        $tiempo = strtotime($datetime);

        $diferencia = intval($actual) - intval($tiempo);

        $minuto  = 60;
        $hora    = 3600;
        $dia     = 86400;
        $mes     = 2592000;
        $anio    = 31536000;

        if($diferencia < $minuto)
        {

            $a = floor($diferencia);
            $sx = $a == 1 ? $sx = "" : "s";
            return $a.' segundo'.$sx;
        }

        if($diferencia < $hora)
        {

            $a = floor($diferencia / $minuto );
            $sx = $a == 1 ? $sx = "" : "s";
            return $a.' minuto'.$sx;
        }

        if($diferencia < $dia)
        {
            $a = floor($diferencia / $hora );
            $sx = $a == 1 ? $sx = "" : "s";
            return $a.' hora'.$sx;
        }

        if($diferencia < $mes)
        {
            $a = floor($diferencia / $dia );
            $sx = $a == 1 ? $sx = "" : "s";
            return $a.' dia'.$sx;
        }

        if($diferencia < $anio)
        {
            $a = floor($diferencia / $mes );
            $sx = $a == 1 ? $sx = "" : "es";
            return $a.' mes'.$sx;
        }

        if($diferencia >= $anio)
        {

            $a = floor($diferencia / $anio );
            $sx = $a == 1 ? $sx = "" : "s";
            return $a.' año'.$sx;
        }

    }

    public function getYoutubeID($url)
    {
        $tube = parse_url($url);

        if ($tube["path"] == "/watch")
        {
            parse_str($tube["query"], $query);
            $id = $query["v"];
        }
        else
        {
            $id = "";
        }

        return $id;
    }

    public function menuCategorias($categorias = false)
    {
        $contador = 0;

        for($n=1; $n<=3; $n++)
        {
            echo '<div class="row">';

            for($i=1; $i<=3; $i++)
            {
                if(isset($categorias[$contador]))
                {
                    echo '<div class="col-lg-4">';
                    echo '<h5><a href="categoria/'.$categorias[$contador]->slug.'">' .$categorias[$contador]->name. '</a></h5>';

                    if( $categorias[$contador]->childs != false )
                    {
                        foreach($categorias[$contador]->childs as $key => $cat)
                        {
                            echo '<h6><a href="categoria/'.$cat->slug.'">' . $cat->name . '</a></h6>';
                        }
                    }

                    echo '</div>';

                }

                $contador++;
            }

            echo '</div>';
        }


    }

    public function productBreadCrumb($product)
    {

        $categoria = $this->CI->categoriesmodel->single($product->category);

        if(!$categoria)
        {
            return false;
        }

        $salida     = false;
        $parents    = $this->CI->categoriesmodel->getParents($categoria->id);

        $salida  = '<ol class="breadcrumb">';
        $salida .= '<li><a href="">Inicio</a></li>';

        if( !$parents == false )
        {
            foreach ($parents as $key => $category)
            {
                $salida .= '<li><a href="categoria/' . $category->slug . '">' . $category->name . '</a></li>';
            }
        }
        $salida .= '<li><a href="categoria/' . $categoria->slug . '">' . $categoria->name . '</a></li>';
        $salida .= '<li>' .$product->name. '</li>';
        $salida .= '</ol>';

       return $salida;



    }

    public function categoryBreadCrumb($id = false, $product = false)
    {
        if( !$id )
        {
            $salida  = '<img src="img/banner.jpg" />';
            $salida .= '<ul class="breadcrumb" id="breadcrumb">';
            $salida .= '<li><a href="">Inicio</a> / </li>';
            $salida .= '<li>Todos</li>';
            $salida .= '</ul>';

            return $salida;
        }

        $salida     = false;
        $parents    = $this->CI->categoriesmodel->getParents($id);
        $category   = $this->CI->categoriesmodel->single($id);

        $salida  = '<img src="img/banner.jpg" />';
        $salida .= '<ul class="breadcrumb" id="breadcrumb">';
        $salida .= '<li><a href="">Inicio</a> / </li>';

        if( !$parents == false )
        {
            foreach ($parents as $key => $cat)
            {
                $salida .= '<li><a href="productos/' . $cat->slug . '">' . $cat->name . '</a> / </li>';
            }
        }
        $salida .= '<li><a href="productos/' . $category->slug . '">' . $category->name . '</a>'. ($product ? ' / ' : '') .'</li>';

        if($product)
        {
            $salida .= '<li class="active">'.$product->name.'</li>';
        }

        $salida .= '</ul>';

       return $salida;

    }

    public function carritoBreadcrumb($estado)
    {
        $html  = '<ol class="breadcrumb">
                     <li><a href="">Inicio</a></li> / ';

        switch ($estado)
        {
            case 'Mis productos':

                $html .= '<li class="active">'. ucfirst($estado).'</li>';

            break;

            case 'Datos de facturacion':

                 $html .= '<li class="active"><a href="carrito">Carrito</a> / </li>';
                 $html .= '<li class="active">'. ucfirst($estado).'</li>';

            break;

            default:
             # code...
            break;
        }

        $html .= '</ol>';

        return $html;
    }

    public function bloqueProducto($product, $col = false)
    {
        if(!$col)
        {
            $col = 3;
        }

        $html = '<div class="col-lg-'.$col.' col-sm-12">
                    <div class="thumbnail product">';

                        if($product->cart[0]->discount != 0 )
                        {
                            $html .= '<div class="descuento">
                                      - ' . $product->cart[0]->discount .'%</div>';
                        }

                        $html .= '<a href="producto/' . $product->id . '/' . $product->slug . '">';



                        $html .= '<img src="' . $product->thumb . '" alt="'. $product->name .'">
                                <div class="caption">
                                    <h4>
                                        <a href="producto/'. $product->id . '/' . $product->slug . '">'. $product->name . '</a>
                                    </h4>';

                                    $sufix          = '';
                                    $muestro_precio = false;
                                    $c              = false;

                                    if( $product->cart != false && count($product->cart) == 1 && $product->cart[0]->active )
                                    {
                                        $c                  = $product->cart[0];
                                        $muestro_precio     = true;
                                    }
                                    elseif($product->cart != false && count($product->cart) > 1)
                                    {

                                        $precios = array();

                                        foreach($product->cart as $k => $p)
                                        {
                                            $precios[$k]    = intval($p->price);

                                        }

                                        asort($precios);

                                        $muestro_precio     = true;
                                        $sufix              = 'Desde ';
                                        $k = min($precios);
                                        $key                = array_search($k, $precios);
                                        $c                  = $product->cart[$key];

                                        //var_dump($precios);
                                        //var_dump($c);
                                       // var_dump($product->cart);


                                    }

                                    if( $muestro_precio )
                                    {

                                        $html .= '<p class="precio-sin-descuento">';

                                        if($c->discount != 0)
                                        {
                                            $html .= '<del>' . $this->getCurrency($c) . ' ' . $this->precio($c, false) . '</del>';
                                        }

                                        $html .= '</p>

                                        <p class="precio"><mark>' . $sufix . $this->getCurrency($c) . ' ' . $this->precio($c, true) . '</mark>
                                            <small>IVA inc.</small>
                                        </p>';

                                    }

                                $html .= '</div>
                        </a>

                    </div>
                </div>';

        return $html;
    }



	public function getThumb($img = false)
	{
        $objeto = $this->CI->imgmodel->img($img);

        $file = $objeto->number.'_thumb.'.$objeto->extension;

		if(file_exists('./pics/'.$objeto->product.'/'.$file))
		{
			return  'pics/'.$objeto->product.'/'.$file;
		}

		return 'img/img-vacia.png';
	}

    public function getLargeImg($img = false)
    {

        $objeto = $this->CI->imgmodel->img($img);

        $file = $objeto->number.'.'.$objeto->extension;

        if(file_exists('./pics/'.$objeto->product.'/'.$file))
        {
            return  'pics/'.$objeto->product.'/'.$file;
        }

        return 'img/img-vacia.png';

    }

	// public function checkbox($modelo, $activar = true)
	// {

	// 	$this->CI->load->model($modelo, 'model');

	// 	if(isset($_POST['items']))
 //        {
 //            $items = '';
 //            foreach($_POST as $key => $value)
 //            {
 //                if($_POST['items'] == 'eliminar')
 //                {
 //                    if($key != 'items'){

 //                        $items .= $key.', ';
 //                    }
 //                }
 //                elseif($_POST['items'] == 'activar')
 //                {
 //                    if($activar)
 //                    {
 //                        if($key != 'items')
 //                        {
 //                            $this->CI->model->setActive($key, true);
 //                            $data['msj'] = "Activacion exitosa";
 //                        }
 //                    }

 //                }
 //                elseif($_POST['items'] == 'desactivar')
 //                {
 //                    if($activar)
 //                    {
 //                        if($key != 'items')
 //                        {
 //                            $this->CI->model->setActive($key, false);
 //                            $data['msj'] = "Desactivacion exitosa";
 //                        }
 //                    }

 //                }
 //            }

 //            if($_POST['items'] == 'eliminar')
 //            {
 //                $items              = substr($items,0, -2);
 //                $cantidad           = explode(', ', $items);
 //                $cantidad           = count($cantidad);
 //                $data['items']      = $items;
 //                $data['cantidad']   = $cantidad;
 //                $data['tipo']       = 'masivo';

 //                if($cantidad == 1)
 //                {
 //                    if($this->CI->model->delete($items))
 //                    {
 //                        $data['msj'] = "Producto eliminado con exito";
 //                    }
 //                    else
 //                    {
 //                       $data['msj'] = "Se ha producido un error al eliminar el producto";
 //                    }
 //                }
 //                else
 //                {
 //                    $this->CI->load->view('admin/confirmar.php', $data);
 //                }
 //            }
 //            else
 //            {
 //                $data['items']  = 'centros';

 //            }
 //        }
 //        elseif(isset($_POST['confirmar']))
 //        {

 //            foreach($_POST as $key => $value)
 //            {
 //                if($key != 'confirmar')
 //                {
 //                    $this->CI->model->delete($value);
 //                }
 //            }

 //            $data['msj'] = "Productos eliminados con exito";
 //        }
	// }


    public function checkboxMsg()
    {

        $this->CI->load->model('messagesmodel', 'model');

        if(isset($_POST['items']))
        {
            $items = '';
            foreach($_POST as $key => $value)
            {
                if($_POST['items'] == 'eliminar')
                {
                    if($key != 'items'){

                        $items .= $key.', ';
                    }
                }
                elseif($_POST['items'] == 'activar')
                {

                    if($key != 'items')
                    {
                        $this->CI->model->setActive($key, true);
                        $data['msj'] = "Activacion exitosa";
                    }
                }
                elseif($_POST['items'] == 'desactivar')
                {
                    if($key != 'items')
                    {
                        $this->CI->model->setActive($key, false);
                        $data['msj'] = "Desactivacion exitosa";
                    }
                }
            }

            if($_POST['items'] == 'eliminar')
            {
                $items              = substr($items,0, -2);
                $cantidad           = explode(', ', $items);
                $cantidad           = count($cantidad);
                $data['items']      = $items;
                $data['cantidad']   = $cantidad;
                $data['tipo']       = 'masivo';

                if($cantidad == 1)
                {
                    if($this->CI->model->delete($items))
                    {
                        $data['msj'] = "Producto eliminado con exito";
                    }
                    else
                    {
                       $data['msj'] = "Se ha producido un error al eliminar el producto";
                    }
                }
                else
                {
                    $this->CI->load->view('admin/confirmar.php', $data);
                }
            }
            else
            {
                $data['items']  = 'centros';

            }
        }
        elseif(isset($_POST['confirmar']))
        {

            foreach($_POST as $key => $value)
            {
                if($key != 'confirmar')
                {
                    $this->CI->model->delete($value);
                }
            }

            $data['msj'] = "Productos eliminados con exito";
        }
    }

    function text($text, $words)
    {
        $text = strip_tags($text);
        $text = str_replace("  ", " ", $text);
        $array = explode(" ", $text);

        $temp = "";
        foreach($array as $key => $value)
        {
            if($key < $words)
            {
                $temp .= $value . " ";
            }

        }

        return trim($temp);


    }


    function sendEmail($data = false)
    {

        $para  = $data['to'];

        $título = $data['subject'];

        $mensaje = $data['html'];

        $cabeceras  = 'MIME-Version: 1.0' . "\r\n";
        $cabeceras .= 'Content-type: text/html; charset=UTF-8' . "\r\n";

        $cabeceras .= 'To: '.$this->CI->config->item('site_name').' <'.$data['to'].'>' . "\r\n";
        $cabeceras .= 'From: '.$this->CI->config->item('site_name').' <'.$this->CI->config->item('smtp_user').'>' . "\r\n";
        $cabeceras .= 'Subject: ' . $data['subject'];
        //$cabeceras .= 'Cc: birthdayarchive@example.com' . "\r\n";
        //$cabeceras .= 'Bcc: birthdaycheck@example.com' . "\r\n";

        return mail($para, $título, $mensaje, $cabeceras);
        
        // if( !$data )
        // {
        //     return;
        // }

        // $config = array(

        //     'protocol'      => 'smtp',
        //     'smtp_host'     => $this->CI->config->item('smtp_host'),
        //     'smtp_port'     => 25,
        //     'smtp_user'     => $this->CI->config->item('smtp_user'),
        //     'smtp_pass'     => $this->CI->config->item('smtp_pass'),
        //     'mailtype'      => 'html',
        //     'charset'       => 'UTF-8',
        //      // 'smtp_crypto'   => 'tls',
        // );

        // $this->CI->load->library('email', $config);
        // $this->CI->email->set_newline("\r\n");

        // $this->CI->email->from($this->CI->config->item('smtp_user'), $this->CI->config->item('site_name') );
        // $this->CI->email->to( $data['to'] );
        // $this->CI->email->reply_to( $data['reply_to'] );
        // $this->CI->email->subject( $data['subject'] );
        // $this->CI->email->message( $data['html'] );

        // if( $this->CI->config->item('email_to_bcc') )
        // {
        //     $this->CI->email->bcc( $this->CI->config->item('email_to_bcc') );
        // }

        // return $result = $this->CI->email->send(FALSE);

    }

    public function mail($data = false)
    {
        
        $para  = $data['to'];

        $título = $data['subject'];

        $mensaje = $data['html'];

        $cabeceras  = 'MIME-Version: 1.0' . "\r\n";
        $cabeceras .= 'Content-type: text/html; charset=UTF-8' . "\r\n";

        $cabeceras .= 'To: '.$this->CI->config->item('site_name').' <'.$data['to'].'>' . "\r\n";
        $cabeceras .= 'From: '.$this->CI->config->item('site_name').' <'.$this->CI->config->item('smtp_user').'>' . "\r\n";
        $cabeceras .= 'Subject: ' . $data['subject'];
        //$cabeceras .= 'Cc: birthdayarchive@example.com' . "\r\n";
        //$cabeceras .= 'Bcc: birthdaycheck@example.com' . "\r\n";

        return mail($para, $título, $mensaje, $cabeceras);

    }

    private $contador = 1;

    public function prueba($array, $parent)
    {

        foreach ($array as $key => $value)
        {
            $salida = "";
            $selected = $value->id == $parent ? 'selected' : '';
            for($i = 0; $i<=$this->contador; $i++)
            {
                $salida .= "&nbsp;&nbsp;&nbsp;";
            }
            echo '<option class="option_'.$this->contador.'" value="'.$value->id.'" '.$selected.' >'. $salida . ' - ' . $value->name.'</option>';
            if($value->childs != false)
            {
                $this->contador++;
                $this->prueba($value->childs, $parent);
            }



        }

        $this->contador = 1;

    }

    public $ids = array();

    public function categoryChildsIds($array)
    {

        if( $array != false )
        {
            foreach ($array as $key => $value)
            {
                $this->ids[] = $value->id;
                if($value->childs != false)
                {
                    $this->categoryChildsIds($value->childs);
                }

            }
        }


        return $this->ids;

    }


    public function liquidacion($moneda = 'PES')
    {

        if($moneda != 'PES' && $moneda != 'DOL')
        {
            $moneda = 'PES';
        }


        if( $this->CI->cart->total_items() > 0 )
        {
           // $this->CI->load->model('productosmodelo');

            $total = 0;

            foreach( $this->CI->cart->contents() as $product )
            {

                $tmp = 0;
                if( $product['options']['moneda'] != $moneda )
                {

                    if($moneda == 'PES')
                    {
                        $tmp = $product['price'] * $this->CI->settingsmodel->variables('valor_dolar_promedio');
                    }
                    else
                    {
                        $tmp = $product['price'] / $this->CI->settingsmodel->variables('valor_dolar_promedio');
                    }

                }
                else
                {
                    $tmp = $product['price'];
                }

                $tmp *= $product['qty'];



                $total += $tmp;

            }

            return $total;
        }

        return 0;




    }

    function getDateString($date)
    {
        $d      = explode(' ', $date);

        $tmp    = explode("-", $d[0]);
        $year   = $tmp[0];
        $month  = $tmp[1];
        $day    = $tmp[2];

        $month_string = "";

        switch ($month)
        {
            case '01':
                $month_string = "Enero";
                break;
            case '02':
                $month_string = "Febrero";
                break;
            case '03':
                $month_string = "Marzo";
                break;
            case '04':
                $month_string = "Abril";
                break;
            case '05':
                $month_string = "Mayo";
                break;
            case '06':
                $month_string = "Junio";
                break;
            case '07':
                $month_string = "Julio";
                break;
            case '08':
                $month_string = "Agosto";
                break;
            case '09':
                $month_string = "Setiembre";
                break;
            case '10':
                $month_string = "Octubre";
                break;
            case '11':
                $month_string = "Noviembre";
                break;
            case '12':
                $month_string = "Diciembre";
                break;

            default:
                # code...
                break;
        }


        return $day. ' de ' . $month_string . ' de ' . $year;
    }


    public function masivo($action, $items, $model)
    {
        $this->CI->load->model($model, 'modelo');

        $response = new stdClass();
        $response->success = false;
        $response->text = '';

        if( !is_array($items) )
        {
            return false;
        }

        switch ($action)
        {
            case 'activar':

                foreach($items as $key => $id)
                {
                    $this->CI->modelo->set_active($id, true);
                }

                $response->success = true;

            break;

            case 'desactivar':

                foreach($items as $key => $id)
                {
                    $this->CI->modelo->set_active($id, false);
                }

                $response->success = true;

            break;

            case 'eliminar':

                foreach($items as $key => $id)
                {
                    $this->CI->modelo->delete($id);
                }

                $response->success = true;

            break;

            default:

            break;
        }


        return json_encode($response);
    }

    public function orderList($slug, $order, $inicio)
    {
        $titulo = 'Ordenar productos';

        switch ($order)
        {
            case 'products.id DESC':
                $titulo = 'Más nuevos';
            break;

            case 'product_price ASC':
                $titulo = 'Precio : Menor a mayor';
            break;

            case 'product_price DESC':
                $titulo = 'Precio : Mayor a menor';
            break;

            default:
                $titulo = 'Ordenar productos';
            break;
        }

        $html = '<div class="dropdown pull-right" id="ordenador">

                    <button class="btn btn-default dropdown-toggle" type="button" id="dropdownMenu1" data-toggle="dropdown" aria-haspopup="true" aria-expanded="true">
                        '.$titulo.'
                        <span class="caret"></span>
                    </button>

                    <ul class="dropdown-menu" aria-labelledby="dropdownMenu1">

                        <li><a href="productos/'. $slug . '/precio_desc/' . $inicio.'" >Precio : Mayor a menor</a></li>
                        <li><a href="productos/'. $slug . '/precio_asc/' . $inicio.'" >Precio : Menor a mayor</a></li>
                        <li><a href="productos/'. $slug . '/id_desc/' . $inicio.'" >Más nuevos</a></li>

                    </ul>

                 </div>';

        return $html;
    }


    public static function deleteDir($dirPath)
    {
        if (! is_dir($dirPath)) {
            throw new InvalidArgumentException("$dirPath must be a directory");
        }
        if (substr($dirPath, strlen($dirPath) - 1, 1) != '/') {
            $dirPath .= '/';
        }
        $files = glob($dirPath . '*', GLOB_MARK);
        foreach ($files as $file) {
            if (is_dir($file)) {
                self::deleteDir($file);
            } else {
                unlink($file);
            }
        }
        rmdir($dirPath);
    }


}
