<?php

Class Render{

	private $CI;

	public function __construct()
	{
		$this->CI =& get_instance();
        $this->CI->load->model('settingsmodel');
        $this->CI->load->model('categoriesmodel');
        $this->CI->load->model('productsmodel');
	}

    public function product($product = false, $clase = '')
    {
        if(!$product) return false;

        $data['product'] = $product;
        $data['clase']   = $clase;

        return $this->CI->load->view('site/render/producto', $data, true);
    }

    public function destacado($product = false)
    {
        if(!$product) return false;

        $data['product'] = $product;

        return $this->CI->load->view('site/render/destacado', $data, true);
    }

    public function sidebarProduct($product = false)
    {

        if(!$product) return false;

        $data['product'] = $product;

        return $this->CI->load->view('site/render/sidebar-product', $data, true);
    }

    public function sidebarProductImportant($product = false)
    {

        if(!$product) return false;

        $data['product'] = $product;

        return $this->CI->load->view('site/render/sidebar-product-important', $data, true);
    }


    public function formulario()
    {

        return $this->CI->load->view('site/render/formulario', false, true);

    }

    public function video($video = false)
    {
        if(!$video) return false;

        $data['video'] = $video;

        return $this->CI->load->view('site/render/video', $data, true);

    }

    public function novedad($novedad = false)
    {
        if(!$novedad) return false;

        $data['novedad'] = $novedad;

        return $this->CI->load->view('site/render/novedad', $data, true);

    }


    public function mapa()
    {
        $this->CI->load->model('mapamodelo');

        $data['branches'] = $this->CI->mapamodelo->get();

        $this->CI->load->view('site/render/mapa', $data);
    }

    public function cartOrder()
    {
        return $this->CI->load->view('site/render/cart_order', false, true);
    }

    public function carrito_header($mostrar = false)
    {

        $this->CI->load->model('cartmodel');

        $cart = false;
        $html = "";

        if( $this->CI->cart->total_items() > 0 )
        {
            $cart = array();

            foreach ($this->CI->cart->contents() as $key => $items)
            {
                $cart[$key] = $this->CI->productsmodel->single($items['id']);

                if( $cart[$key] )
                {
                    $cart[$key]->items = $items;
                }
                else
                {
                    unset($cart[$key]);
                }

            }

        }

        $data['cart']   = $cart;
        $data['mostrar']  = $mostrar;

        $html = $this->CI->load->view('site/render/cart-header-productos', $data, true);

        return $html;

    }


    public function productBreadcrumb($product = false)
    {
        if(!$product) return false;

        $categoria = $this->CI->categoriesmodel->single($product->category);

        if(!$categoria) return false;

        $parents    = $this->CI->categoriesmodel->getParents($categoria->id);

        $data = array(

            'product'   => $product,
            'parents'   => $parents,
            'categoria' => $categoria,

        );

        return $this->CI->load->view('site/render/product-breadcrumb', $data, true);
    }

    public function categoryBreadcrumb($id = false)
    {
        $data = array();

        $data['parents']    = false;
        $data['categoria']  = false;

        if($id)
        {
            $categoria = $this->CI->categoriesmodel->single($id);

            $parents    = $this->CI->categoriesmodel->getParents($categoria->id);

            $data = array(

                'parents'   => $parents,
                'categoria' => $categoria,

            );
        }

        return $this->CI->load->view('site/render/category-breadcrumb', $data, true);
    }

    public function searchBreadcrumb()
    {
        return $this->CI->load->view('site/render/search-breadcrumb', false, true);
    }

    public function offersBreadcrumb()
    {
        return $this->CI->load->view('site/render/offers-breadcrumb', false, true);
    }

    public function tablaGastosEnvio()
    {


        $response               = array();
        $response['productos']  = array();

        foreach( $this->CI->cart->contents() as $key => $value )
        {
            $single                                  = $this->CI->productsmodel->single( $value['id'] );
            $response['productos'][$key]             = new stdClass();
            $response['productos'][$key]->producto   = $single;

        }

        return $this->CI->load->view('site/render/costos-envio', $response, true);

    }

}
