<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed'); 

class CategoriesModel extends CI_Model{

	private $table_name = "categories";

	public function __construct()
	{
		parent::__construct();
	}

	public function single($id)
	{
		$sql = "SELECT * FROM $this->table_name
				WHERE $this->table_name.id = $id
				LIMIT 0,1";

		$query = $this->db->query($sql);

		if($query->num_rows() == 1)
		{
			return  $query->row();
		}	

		return false;
	}

	public function last()
    {
        $query  = $this->db->query("SELECT * FROM $this->table_name ORDER BY id DESC LIMIT 0,1");
        $row    = $query->row();
        return $row->id;
    }

	public function single_slug($slug = false)
	{
		if($slug == false)
		{
			return false;
		}

		$sql = "SELECT * FROM $this->table_name
				WHERE $this->table_name.slug = '$slug'
				LIMIT 0,1";

		$query = $this->db->query($sql);

		if($query->num_rows() == 1)
		{
			return  $query->row();
		}

		return false;

	}

	public function get($active = false)
	{

		$a = "";
		if($active == true)
		{
			$a = "AND active = 1";
		}

		$sql = "SELECT * FROM categories
				WHERE 1 AND parent = 0
				$a
				ORDER BY categories.order ASC, name ASC";

		$res = $this->db->query($sql);

		if($res->num_rows() > 0)
		{
			$categories = new stdClass();
			$categories = $res->result();

			foreach($categories as $key => $category)
			{
				$childs = $this->getChilds($category->id);
				$category->childs = $childs; 
			}

			$categories = $this->addImages($categories);
			
			return $categories;
		}		

		return false;
	}

	public function getChilds($id, $active = false)
	{
		$a = "";
		if($active == true)
		{
			$a = "AND active = 1";
		}

		$sql = "SELECT * FROM categories
				WHERE parent = $id
				$a
				ORDER BY categories.order ASC, name ASC";

		$res = $this->db->query($sql);
		$categories = false;

		if($res->num_rows() > 0)
		{
			$categories = $res->result();

			foreach($categories as $key => $category)
			{
				$childs = $this->getChilds($category->id);
				$category->childs = $childs; 
			}
		
		}

		return $this->addImages($categories);

	}


	public function totalChilds($parent)
	{

		$sql 			= "SELECT COUNT(*) AS total FROM categories
						   WHERE categories.parent = $parent";

		$consulta 		= $this->db->query($sql);

		return $consulta->row()->total;

	}

	public function mainCategories($active = false)
	{
		$a = "";
		if($active == true)
		{
			$a = "AND active = 1";
		}

		$sql = "SELECT * FROM categories
				WHERE parent = 0
				$a
				ORDER BY categories.active DESC ,categories.order ASC";

		$res = $this->db->query($sql);

		if($res->num_rows() > 0)
		{
			$categories = new stdClass();
			$categories = $res->result();

			foreach($categories as $key => $category)
			{
				$childs = $this->getChilds($category->id);
				$category->childs = $childs; 
			}

			$categories = $this->addImages($categories);
			
			return $categories;
		}

		return false;
	}

	public function getParents($category, $active = true)
	{

		$c = $category;

        $categories = array();

        $i = 1;

        while( $this->single($c)->parent != 0 )
        {
            
            $parent             = $this->single($this->single($c)->parent);
            $c                  = $parent->id;
            $categories[$i]     = $parent;
            $i++;       
            
        }

        $categories = array_reverse($categories);

        return $categories;
	}

	public function add($data)
	{

        if($this->db->insert($this->table_name, $data))
        {
            return true;
        }

        return false;
	}

	public function set_active($id, $active = false)
    {

        $a = $active == true ? 1 : 0;

        $sql = "UPDATE $this->table_name
                SET active = $a
                WHERE id = $id";

        $this->db->query($sql);
    }

    public function update($category = false, $data = array())
    {
        if( ! $category)
        {
            return false;
        }

        $this->db->where('id', $category);

        if($this->db->update($this->table_name, $data))
        {
            return true;
        }

        return false;
    }

    public function delete($category)
    {
        $sql = "DELETE FROM $this->table_name
                WHERE id = $category";

        if($this->db->query($sql))
        {   
            return true;
        }

        return false;
    }

    public function delete_all()
    {
        $sql = "DELETE FROM $this->table_name";

        if($this->db->query($sql))
        {   
            return true;
        }

        return false;
    }

    private function addImages($object)
    {
    	if($object != false)
    	{
    		foreach ($object as $key => $category)
    		{	
    			$category->img 	= false;
    			

    			if( file_exists('./img/categorias/'.$category->id.'/02.jpg') )
    			{
    				$category->img = 'img/categorias/'.$category->id.'/02.jpg';
    			}
    			else
    			{
    				$category->img = 'img/img-vacia-cat.png';	
    			}
    			// if( $this->getParent($category->id) == false )
    			// {
    			// 	if( file_exists('./img/categorias/graficas/'.$category->slug.'.png') )
    			// 	{
    			// 		$category->grafica = 'img/categorias/graficas/'.$category->slug.'.png';
    			// 	}
    			// }


    		}
    	}

    	return $object;
    }

}