<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class NewsModel extends CI_Model{

	private $table_name = "news";

	public function __construct()
	{
		parent::__construct();
		$this->load->model('newscatmodel');
	}

	public function single($id)
	{
		$sql = "SELECT news.*, news_categories.title cat_title, news_categories.slug cat_slug FROM $this->table_name
				LEFT JOIN news_categories
				ON news_categories.id = $this->table_name.category
				WHERE $this->table_name.id = $id
				LIMIT 0,1";

		$query = $this->db->query($sql);

		if($query->num_rows() == 1)
		{
			$single = $query->row();

			if($single->video != '')
			{

				$i = $this->functions->getYoutubeID($single->video);

				$single->thumb = "http://img.youtube.com/vi/".$i."/0.jpg";
				$single->img = true;
			}
			else
			{
				$res = $this->addExtras( $query->result() );
			}

			return $single;
		}

		return false;
	}

	public function important($id = false, $limit = 4)
	{
		$a = '1';

		if($id)
		{
			$a = "id != '$id'";
		}

		$sql = "SELECT * FROM $this->table_name
				WHERE $a
				AND $this->table_name.destacado = 1
				AND $this->table_name.active = 1
				ORDER BY RAND()
				LIMIT $limit";

		$res = $this->db->query($sql);

        if( $res->num_rows() > 0 )
        {
        	return $this->addExtras( $res->result() );
        }

        return false;

	}

	public function relevants($id = false, $limit = 4)
	{

		if(!$id) return false;

		$sql = "SELECT * FROM news
				WHERE news.id != $id
				AND news.active = 1
				ORDER BY RAND()
				LIMIT $limit";

		$res = $this->db->query($sql);

        if( $res->num_rows() > 0 )
        {
        	return $this->addExtras( $res->result() );
        }

        return false;

	}

	public function count($active = false)
    {

        $sql_extra = "";

        if($active)
        {
            $sql_extra = " AND active = 1 ";
        }

        $sql = "SELECT COUNT(*) FROM news WHERE 1 ".$sql_extra;

        $res = $this->db->query($sql);

        return $res->row()->{'COUNT(*)'};
    }


	public function get($active = false, $start = 0, $results = 99000, $category = false)
	{

		$a = "";

		if($active == true)
		{
			$a = " AND active = 1 ";
		}

		if($category != false)
		{
			if( is_int($category) )
			{
				$a .= " AND category = '$category' ";
			}
			else
			{

				$objeto = $this->newscatmodel->singleCategoryFromSlug($category);

				if( $objeto )
				{
					$a .= " AND category = '$objeto->id' ";
				}
				else
				{
					return false;
				}

			}

		}

		$sql = "SELECT * FROM $this->table_name
				WHERE 1
				$a
				ORDER BY 'order' ASC, id DESC
				LIMIT $start, $results";

		$res = $this->db->query($sql);

		if($res->num_rows() > 0)
		{
			$results = $res->result();

			foreach ($results as $key => $result)
			{
				$result->thumb = 'img/img-vacia.png';
				$result->large = 'img/img-vacia.png';

				if($result->video != '')
				{

					$i = $this->functions->getYoutubeID($result->video);

					$result->thumb = "http://img.youtube.com/vi/".$i."/0.jpg";
					$result->large = $result->thumb;
					$result->img   = true;
				}
				else
				{
					if(file_exists('./img/noticias/'.$result->id.'/01.jpg'))
					{
						$result->large = 'img/noticias/'.$result->id.'/01.jpg';
					}
					if(file_exists('./img/noticias/'.$result->id.'/02.jpg'))
					{
						$result->thumb = 'img/noticias/'.$result->id.'/02.jpg';
					}
				}

			}

			return $results;
		}

		return false;
	}


	public function getVideos($active = false, $start = 0, $results = 99000)
	{
		$a = "";
		if($active == true)
		{
			$a = " AND active = 1 ";
		}

		$sql = "SELECT * FROM $this->table_name
				WHERE 1 and video != ''
				$a
				ORDER BY 'id' ASC
				LIMIT $start, $results";

		$res = $this->db->query($sql);

		if($res->num_rows() > 0)
		{
			$results = $res->result();

			foreach ($results as $key => $result)
			{
				$i = $this->functions->getYoutubeID($result->video);

				$result->thumb = "http://img.youtube.com/vi/".$i."/0.jpg";
			}

			return $results;
		}

		return false;
	}


	public function getCategories($active = false)
	{

		$a = "";

		if($active == true)
		{
			$a = "AND active = 1";
		}

		$sql = "SELECT * FROM news_categories
				WHERE 1
				$a
				ORDER BY 'name' ASC, id ASC";

		$res = $this->db->query($sql);

		if($res->num_rows() > 0)
		{
			$results = $res->result();

			return $results;
		}

		return false;
	}

	public function add($data)
	{

        if($this->db->insert($this->table_name, $data))
        {
            return true;
        }

        return false;
	}

	// public function addCategory($data)
	// {
	// 	if($this->db->insert('news_categories', $data))
 //        {
 //            return true;
 //        }

 //        return false;
	// }

	public function last()
    {
        $query  = $this->db->query('SELECT * FROM news ORDER BY id DESC LIMIT 0,1');
        $row    = $query->row();
        return $row->id;
    }

	public function setActive($id, $active = false)
    {

        $a = $active == true ? 1 : 0;

        $sql = "UPDATE $this->table_name
                SET active = $a
                WHERE id = $id";

        $this->db->query($sql);
    }

    public function update($id = false, $data = array())
    {
        if( ! $id)
        {
            return false;
        }

        $this->db->where('id', $id);

        if($this->db->update($this->table_name, $data))
        {
            return true;
        }

        return false;
    }

    // public function updateCategory($id = false, $data = array())
    // {
    // 	if( ! $id)
    //     {
    //         return false;
    //     }

    //     $this->db->where('id', $id);

    //     if($this->db->update('news_categories', $data))
    //     {
    //         return true;
    //     }

    //     return false;
    // }

    public function delete($brand)
    {
        $sql = "DELETE FROM $this->table_name
                WHERE id = $brand";

        if($this->db->query($sql))
        {
            return true;
        }

        return false;
    }

    public function search($keyword)
    {

    	if( $keyword == '' ) return false;

    	$sql = "SELECT * FROM $this->table_name
    			WHERE MATCH($this->table_name.title) AGAINST('$keyword' IN BOOLEAN MODE)";

    	$res = $this->db->query($sql);

    	if( $res->num_rows() > 0 )
    	{
    		return $this->addExtras( $res->result() );
    	}

    	return false;

    }


    private function addExtras($object)
    {

        foreach($object as $news)
        {

        	$news->thumb = 'img/img-vacia.png';
			$news->large = 'img/img-vacia.png';
			$news->img   = false;

			if($news->video != '')
			{

				$i = $this->functions->getYoutubeID($news->video);

				$news->thumb = "http://img.youtube.com/vi/".$i."/0.jpg";
				$news->large = $news->thumb;
				$news->img   = true;
			}
			elseif(file_exists('./img/noticias/'.$news->id.'/01.jpg') && file_exists('./img/noticias/'.$news->id.'/02.jpg'))
        	{

        		$news->thumb = 'img/noticias/'.$news->id.'/02.jpg';
				$news->large = 'img/noticias/'.$news->id.'/01.jpg';
				$news->img   = true;
        	}

        	$news->permalink = base_url('novedades');

        }

        return $object;
    }
}
