<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Ordersmodel extends CI_Model{
    
    private $table_name = "orders";

    public function __construct()
    {
        parent::__construct();
    }

    public function get($id = false)
    {
        
        $a = '';

        if( $id != false)
        {
            $a = "AND $this->table_name.user = $id";    
        }
        $sql = "SELECT * FROM $this->table_name
                WHERE 1
                $a
                ORDER BY id DESC";

        $query = $this->db->query($sql);

        if($query->num_rows() > 0 )
        {
            $res = $query->result();
            $res = $this->addExtras($res);
            return $res;
        }   

        return false;

    }

    public function addOrderProducts($order_id)
    {
        foreach( $this->cart->contents() as $key => $value )
        {
            $array = array(

                'id'            => null,
                'order_id'      => $order_id,
                'product_id'    => $value['id'],
                'price'         => $value['price'],
                'qty'           => $value['qty'],
                'subtotal'      => $value['subtotal'],
                'discount'      => $value['discount'],

            );

            $this->db->insert('order_products', $array);            

        }

    }

    public function delete($id)
    {
        $sql = "DELETE FROM $this->table_name
                WHERE id = $id";

        if($this->db->query($sql))
        {   
            return true;
        }

        return false;
    }

    public function single($id)
    {
        $sql = "SELECT orders.*, users.name user_name, users.lastname user_lastname FROM $this->table_name
                LEFT JOIN users
                ON users.id  = $this->table_name.user

                WHERE $this->table_name.id = $id
                LIMIT 0,1";

        $query = $this->db->query($sql);
        
        if($query->num_rows() == 1)
        {   
            $r = $this->addExtras( array($query->row()) );
            return $r[0];
        }   

        return false;
    }

    public function last()
    {
        $query  = $this->db->query('SELECT * FROM orders ORDER BY id DESC LIMIT 0,1');
        $row    = $query->row();
        return $row->id;
    }

    public function add($data = false)
    {

        if($this->db->insert($this->table_name, $data))
        {
            return true;
        }

        return false;
    }

    public function update($id = false, $data = array())
    {
        if( !$id )
        {
            return false;
        }

        $this->db->where('id', $id);

        if($this->db->update($this->table_name, $data))
        {
            return true;
        }

        return false;
    }

    public function set_active($id, $active = false)
    {

        $a = $active == true ? 1 : 0;

        $sql = "UPDATE $this->table_name
                SET active = $a
                WHERE id = $id";

        $this->db->query($sql);
    }

    private function getOrderProducts($order_id)
    {      
        if( !$order_id ) return false;

        $sql = "SELECT * FROM order_products
                WHERE order_products.order_id = '$order_id'";

        $res = $this->db->query( $sql );

        if( $res->num_rows() > 0 )
        {
            $res = $res->result();

            foreach( $res as $key => $value )
            {
                $value->original = $this->productsmodel->single($value->product_id);
            }

            return $res;
        }

        return false;
    }
    

    private function addExtras($object)
    {
        $this->load->model('usersmodel');

        foreach($object as $order)
        {
            $order->products = $this->getOrderProducts($order->id);
            
            $order->user = $this->usersmodel->single($order->user); 
        }

        return $object;
    }
      
}

?>