<?php

class ProductsModel extends CI_Model{

	private $table_name = "products";

    public function __construct()
    {
        parent::__construct();
        $this->load->model('imgmodel');
        $this->load->model('categoriesmodel');
        $this->load->model('cartmodel');
    }

    public function last()
    {
        $sql = "SELECT * FROM $this->table_name
                ORDER BY id DESC
                LIMIT 1";

        $res = $this->db->query($sql);

        return $res->row()->id;
    }

    public function buscar($key = false, $start = 0, $limit = 8)
    {
        if(!$key)
        {
            return false;
        }

        $sql = "SELECT products.*, categories.name category_name FROM products

                LEFT JOIN categories
                ON categories.id = products.category

                WHERE products.active = 1
                AND (products.name LIKE '%".$key."%' OR MATCH(products.name) AGAINST ('$key') )
                OR (categories.name LIKE '%".$key."%')
                OR MATCH(products.tags) AGAINST ('$key')
                LIMIT $start, $limit";


        $res = $this->db->query($sql);

        if($res->num_rows() > 0)
        {
            return $this->addExtras( $res->result() );
        }

        return false;

    }


    public function get($start = 0, $results = 990000, $order = "id DESC", $categorias = false, $active = false, $img = false)
    {
        $sql_extra = "";

        if($active)
        {
            $sql_extra = " AND products.active = 1 ";
        }

        if($categorias != false)
        {
            $sql_extra .= " AND ( ";

            if( is_array( $categorias ) )
            {
                foreach ($categorias as $key => $cat)
                {
                   $sql_extra .= " category = '$cat' ";

                   if($key != (int) ( count($categorias) - 1 ) )
                   {
                        $sql_extra .= " OR ";
                   }
                }
            }
            else
            {
                $sql_extra .= "category = ".$categorias;
            }


            $sql_extra .= " ) ";

        }

        $start = intval($start);

        $sql = "SELECT products.*, cart.price * ( IF(currency = 'DOL', ".$this->settings->get('dolar').", 1) ) product_price FROM $this->table_name
                LEFT JOIN cart
                ON cart.product = products.id

                WHERE 1
                $sql_extra
                ORDER BY $order
                LIMIT $start, $results";

    	$query = $this->db->query($sql);

    	if($query->num_rows() > 0)
    	{
            $res = $query->result();

            $res = $this->addExtras($res);

            return $res;
    	}

    	return false;
    }

    public function count($categories = false, $active = false) //0, 99000, $this->orden, $this->categoria
    {

        $sql_extra = "";

        if($active)
        {
            $sql_extra = " AND active = 1 ";
        }

        if($categories != false)
        {
            $sql_extra .= " AND ( ";

            if( is_array( $categories ) )
            {
                foreach ($categories as $key => $cat)
                {
                   $sql_extra .= " category = '$cat' ";

                   if($key != (int) ( count($categories) - 1 ) )
                   {
                        $sql_extra .= " OR ";
                   }
                }
            }
            else
            {
                $sql_extra .= "category = ".$categories;
            }

            $sql_extra .= " ) ";

        }

        $sql = "SELECT COUNT(*) FROM products WHERE 1 ".$sql_extra;

        $res = $this->db->query($sql);

        return $res->row()->{'COUNT(*)'};
    }

    public function single($id = false)
    {
        $sql = "SELECT * FROM $this->table_name
                WHERE $this->table_name.id = $id
                LIMIT 0,1";

        $query = $this->db->query($sql);

        if($query->num_rows() == 1)
        {
            $product = $query->result();

            if( ! file_exists('./pics/'.$product[0]->id))
            {
                mkdir('./pics/' . $product[0]->id);
            }

            $product = $this->addExtras($product);

            return $product[0];
        }

        return false;
    }

    public function singleCode($code = false)
    {
        if(!$code)
        {
            return false;
        }
        $sql = "SELECT * FROM $this->table_name
                WHERE $this->table_name.code = '$code'
                LIMIT 0,1";

        $query = $this->db->query($sql);

        if($query->num_rows() == 1)
        {
            $product = $query->row();

            return $product;
        }

        return false;
    }

    public function slug($slug = false)
    {
        $sql = "SELECT * FROM $this->table_name
                WHERE ".$this->table_name.".slug".$this->session->userdata('site_lang_suffix')." = '$slug'
                LIMIT 0,1";

        $query = $this->db->query($sql);

        if($query->num_rows() == 1)
        {
            $product = $query->result();

            $product = $this->addExtras($product);

            return $product[0];
        }

        return false;
    }

    public function add($data)
    {
        if($this->db->insert($this->table_name, $data))
        {
            return true;
        }

        return false;
    }

    public function update($product = false, $data = array())
    {
        if( ! $product)
        {
            return false;
        }

        $this->db->where('id', $product);

        if($this->db->update($this->table_name, $data))
        {
            return true;
        }

        return false;
    }

    public function set_active($id, $active = false)
    {

        $a = $active == true ? 1 : 0;

        $sql = "UPDATE $this->table_name
                SET active = $a
                WHERE id = $id";

        $this->db->query($sql);
    }

    public function delete($producto)
    {
        $sql = "DELETE FROM $this->table_name
                WHERE id = $producto";

        if($this->db->query($sql))
        {
            $this->imgmodel->deleteAll($producto);
            return true;
        }

        return false;
    }


    public function important($results = 8)
    {
        $sql_extra = "";

        $sql = "SELECT * FROM $this->table_name
                WHERE important = 1
                $sql_extra
                AND active = 1
                ORDER BY RAND()
                LIMIT 0, $results";

        $query = $this->db->query($sql);

        if($query->num_rows() > 0)
        {
            $res = $query->result();

            $res = $this->addExtras($res);

            return $res;
        }

        return false;

    }

    public function offers($results = 8)
    {
        $sql_extra = "";

        $sql = "SELECT products.* FROM $this->table_name

                LEFT JOIN cart
                ON cart.product = products.id

                WHERE cart.offer = 1
                AND products.active = 1

                ORDER BY products.order DESC
                LIMIT 0, $results";

        $query = $this->db->query($sql);

        if($query->num_rows() > 0)
        {
            $res = $query->result();

            $res = $this->addExtras($res);

            return $res;
        }

        return false;

    }

    public function relevant($results = 8, $product = false, $category = true)
    {
        $single = $this->single($product);

        $apx = '';

        if( $category )
        {
            $categoria = $single->category;

            $apx = "AND category = '$categoria'";
        }

        $sql = "SELECT * FROM $this->table_name
                WHERE active = 1
                AND id != '$product'
                $apx
                ORDER BY RAND()
                LIMIT 0, $results";

        $query = $this->db->query($sql);

        if($query->num_rows() > 0 )
        {
            $res = $query->result();

            $res = $this->addExtras($res);

            return $res;
        }
        else
        {
            if( !$query->num_rows() ) return false;
            
            return $this->relevant($results, $product, false);
        }

        return false;

    }

    public function addExtras($object)
    {
        $this->load->model('favoritosmodelo');

        foreach($object as $key => $product)
        {

            $category = $this->categoriesmodel->single($product->category);

            if($category != null)
            {
                $product->category_name     = $category->name;
                $product->category_slug     = $category->slug;
            }
            else
            {
                $product->category_name     = "";
                $product->category_slug     = "";
            }

            $product->cart          = $this->cartmodel->productCart( $product->id );

            if( $product->cart )
            {
                $product->cart->precio_formateado = $this->functions->precio($product->cart);
            }

            $product->thumb         = $this->imgmodel->thumb($product->id);
            $product->large         = $this->imgmodel->large($product->id);
            $product->img           = $this->imgmodel->hasImg($product->id);
            $product->permalink     = base_url() . 'producto/' . $product->id . '/' . $product->slug;
            $product->is_favorite   = false;

            $this->load->model('statusmodel');

            if( $this->statusmodel->checkUser() )
            {
                $product->is_favorite = $this->favoritosmodelo->checkFavorito($product->id, $this->session->userdata('id_user') );
            }

        }

        return $object;
    }


}
