<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed'); 

class SearchModel extends CI_Model{

	private $table_name = 'search';

	public function __construct()
	{
		parent::__construct();
		$this->load->model('imgmodel');
        $this->load->model('categoriesmodel');
	}

	public function add($key)
	{
		if($this->exists($key))
		{

			$this->db->where('keyword', $key);
			$sql = "UPDATE $this->table_name
					SET times = times + 1
					WHERE keyword = '$key'";

			if($this->db->query($sql))
			{
				return true;
			}

			return false;
		}
		else
		{	
			$data = array(
				
				'id' 			=> null,
				'keyword' 		=> $key,
				'times'			=> 1,
				'date'			=> date('Y-m-d H:i:s')
			);

			$this->db->insert($this->table_name, $data);
		}
	}

	public function autocompletar($key)
	{
		$consulta = $this->db->query("SELECT products.name FROM products WHERE products.name LIKE '%".$key."%' OR products.code LIKE '%".$key."%' LIMIT 0, 8");
		
		if($consulta->num_rows() > 0)
		{
			$res = $consulta->result();
        	return $res;
		}

		return false;
		
	}

	public function autocompletarActivos($key)
	{
		$consulta = $this->db->query("SELECT products.name FROM products WHERE products.active = 1 and products.name LIKE '%".$key."%' LIMIT 0, 8");
		
		if($consulta->num_rows() > 0)
		{
			$res = $consulta->result();
        	return $res;
		}

		return false;
		
	}

	public function get($key, $active = false)
	{	
		$sql_extra = '';

		if($active)
		{
			$sql_extra .= " AND products.active = 1 ";
		}

		if($this->session->userdata('site_lang') == 'english')
        {
            $sql_extra .= " AND slug_en != '' "; 
        }

		$sql = "SELECT products.* FROM products
				
				WHERE 1
				$sql_extra
				AND (products.name LIKE '%".$key."%'
				OR products.code LIKE '%".$key."%'
				OR products.tags LIKE '%".$key."%')				
				LIMIT 0, 20";

		// $sql = "SELECT * FROM products WHERE MATCH (name,code,tags)
		// 		AGAINST ('$key' IN BOOLEAN MODE)
		// 		LIMIT 0,200";

		$query = $this->db->query($sql);

		if($query->num_rows() > 0)
		{
			$res = $query->result();

            $res = $this->addExtras($res);

            return $res;
		}

		return false;
	}

	public function exists($key)
	{	

		$sql = "SELECT * FROM $this->table_name
				WHERE keyword = '$key'";

		$res = $this->db->query($sql);

		if($res->num_rows() > 0)
		{
			return true;
		}

		return false;


	}

	public function keywords()
	{
		$sql = "SELECT * FROM $this->table_name
				ORDER BY times DESC
				LIMIT 0, 20";

		$res = $this->db->query($sql);

		if($res->num_rows() > 0)
		{
			return $res->result();
		}

		return false;


	}

	public function delete_keywords()
	{
		$sql = "DELETE FROM $this->table_name";

		if($this->db->query($sql))
		{
			return true;
		}

		return false;

	}

	private function addExtras($object)
    {

        foreach($object as $product)
        {
            $category = $this->categoriesmodel->single($product->category);

            if($category != null)
            {
                $product->category_name     = $category->name;
                $product->category_slug     = $category->slug;

            }
            else
            {
                $product->category_name     = "";
                $product->category_slug     = "";
            }

   
            $product->cart = $this->cartmodel->productCart( $product->id );
            
            
            $product->thumb     = $this->imgmodel->thumb($product->id);
            $product->large     = $this->imgmodel->large($product->id);
            $product->img       = $this->imgmodel->hasImg($product->id);
        }

        return $object;
    }


	
}