<?php

class StatusModel extends CI_Model{

    private $tabla_usuarios = "users";
    private $tabla_admin    = "admin";

    public function __construct()
    {        
        parent::__construct();
        $this->load->model('usersmodel');
    }

    public function print_username()
    {
        if( $this->session->userdata('logged_user') )
        {
            return $this->session->userdata('name_user') . ' ' . $this->session->userdata('lastname_user');
        }

        return false;
    }

    public function loggedAdmin()
    {
        if($this->session->userdata('logged_admin') == true)
        {
            return true;
        }
        elseif($this->input->cookie('mail_admin') != '' && $this->input->cookie('pass_admin') != '')
        {
            $mail = $this->input->cookie('mail_admin', true);
            $pass = $this->input->cookie('pass_admin', true);
            $usuario = $this->getAdmin($mail, $pass, false);
            if($usuario != false)
            {
                return true;
            }
            else
            {
                return false;
            }

        }
        else
        {
            return false;
        }
    }

    public function getAdmin($mail, $pass, $encryptado=false)
    {

        if(!$encryptado)
        {
            $pass = md5($pass); 
        }

        $sql = "SELECT * FROM $this->tabla_admin 
                WHERE mail = '".$mail."'
                and pass = '".$pass."'
                and active = '1'"; 

        $consulta   = $this->db->query($sql);
        $resultado  = $consulta->result();

        if($consulta->num_rows() == 1)
        {
            return $consulta->row();

        }
        else
        {
            return false;
        }
    }

    public function getLoggedUser()
    {

        if( $this->checkUser() )
        {   
            return $this->usersmodel->single( $this->session->userdata('id_user') );
        }

        return false;
    }


    public function checkUser()
    {

        if($this->session->userdata('logged_user') == true)
        {
            return true;
        }
        elseif($this->input->cookie('uhc') != '')
        {

            $hash = $this->input->cookie('uhc', true);
            
            $tmp = explode(':', $hash);

            if(!is_array($tmp)) return false;

            if(strlen($tmp[1]) != 32) return false;

            $identifier = $tmp[0];

            $a = substr($identifier, 3);
            $b = substr($a, 0, -3);

            $user = $b;
            $hash = $tmp[1];

            $result = $this->getUserByHash($user, $hash);

            if( $result != false )
            {
                return true;
            }

            return false;

        }
        else
        {
            return false;
        }
    }

    public function getUser($email, $pass, $encryptado=false)
    {

        if(!$encryptado)
        {
            $pass = md5($pass); 
        }
        
        $sql = "SELECT * FROM $this->tabla_usuarios 
                WHERE mail = '".$email."'
                and pass = '".$pass."'
                and active = '1'";

        $consulta = $this->db->query($sql);

        if($consulta->num_rows() == 1)
        {
            return $consulta->row();
        }
        else
        {
            return false;
        }
    }

    public function setUserSession($data, $cookie = false)
    {
        $this->session->set_userdata('id_user', $data->id);
        $this->session->set_userdata('name_user', $data->name);
        $this->session->set_userdata('lastname_user', $data->lastname);
        $this->session->set_userdata('mail_user', $data->mail);
        $this->session->set_userdata('logged_user', true);

        $this->usersmodel->update($data->id, array(

            'last_access'   => date('Y-m-d H:i:s')
        ));

        if($cookie)
        {
            $this->createCookieHash($data->id);
        }
    }

    public function createCookieHash($user_id)
    {
        $this->load->helper('string');

        $tmp = random_string('md5', 32);

        $identificador = rand(100,999) . $user_id . rand(100,999);

        $hash = $identificador . ':' . $tmp;

        $array = array(
            
            'name'   => 'uhc',
            'value'  => $hash,
            'expire' => 60 * 60 * 24 * 7 // una semana
            
            );
    
        $this->input->set_cookie($array);

        $this->load->model('usersmodel');

        $this->usersmodel->update( $this->session->userdata('id_user'), array('cookie_hash' => $tmp , 'cookie_date' => strtotime("+7 days") ));
    }

    public function getUserByHash($user, $hash)
    {
        $user = $this->security->xss_clean($user);
        $hash = $this->security->xss_clean($hash);

        $time = time();

        $sql = "SELECT * FROM users
                WHERE users.id = $user
                AND users.cookie_hash = '$hash'
                AND users.cookie_date > $time";

        $consulta = $this->db->query($sql);

        if($consulta->num_rows() == 1)
        {
            $res = $consulta->row();

            if(file_exists('./img/users/'.$res->id.'/01.jpg'))
            {
                $res->img = 'img/users/'.$res->id.'/01.jpg';
            }
            else
            {
                $res->img = false;
            }

            $this->setUserSession($res, true);

            return $res;
        }
        else
        {
            return false;
        }


    }

    public function logout()
    {
        $this->load->helper('cookie');
        $this->load->model('usersmodel');

        $id = $this->session->userdata('id_user');

        $sess = array('id_user', 'name_user', 'lastname_user', 'mail_user', 'logged_user', 'level_user');

        $this->session->unset_userdata($sess);

        delete_cookie('uhc');

        $data = array('cookie_hash' => false, 'cookie_date' => false);
        
        $this->usersmodel->update($id, $data);

    }
    

}