<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Usersmodel extends CI_Model{
    
    private $table_name = "users";

    public function __construct()
    {
        parent::__construct();
    }
    
    
    public function get($active = false, $start = 0, $results = 990000)
    {
        $a = "";
        if($active == true)
        {
            $a = "AND active = 1";
        }

        $sql    =  "SELECT * FROM $this->table_name
                    WHERE 1
                    $a
                    ORDER BY $this->table_name.lastname ASC
                    LIMIT $start, $results";
        
        $query  = $this->db->query($sql);

        if($query->num_rows() == 0)
        {            
            return false;
        }
        else
        {
            $resultado = $query->result();
            return $resultado;
        }
    }

    public function count($active = false)
    {

        $sql_extra = "";

        if($active)
        {
            $sql_extra = " AND active = 1 ";
        }

        $sql = "SELECT COUNT(*) FROM $this->table_name WHERE 1 ".$sql_extra;

        $res = $this->db->query($sql);

        return $res->row()->{'COUNT(*)'};
    }

    public function single($id)
    {
        if(!$id) return false;
        
        $sql = "SELECT * FROM $this->table_name
                WHERE $this->table_name.id = $id
                LIMIT 0,1";

        $query = $this->db->query($sql);

        if($query->num_rows() == 1)
        {
            return  $query->row();
        }   

        return false;
    }

    public function checkToken($token, $id)
    {

        if( !$token || !$id )
        {
            return false;
        }

        if(strlen($token) != 32)
        {
            return false;
        }

        $sql = "SELECT * FROM users_tmp 
                WHERE users_tmp.token = '$token'
                AND users_tmp.id = '$id'";

        $query = $this->db->query($sql);

        if($query->num_rows() == 1)
        {
            $user = $query->row();

            if( ( time() - $user->token_date ) > $this->config->item('token_limit') )
            {
                return false;
            }

            return true;
        }   

        return false;     

    }

    public function single_tmp($id)
    {
        $sql = "SELECT * FROM users_tmp
                WHERE users_tmp.id = $id
                LIMIT 0,1";

        $query = $this->db->query($sql);

        if($query->num_rows() == 1)
        {
            return  $query->row();
        }   

        return false;
    }

    public function singleMail($mail)
    {
        $sql = "SELECT * FROM $this->table_name
                WHERE $this->table_name.mail = '$mail'
                LIMIT 0,1";

        $query = $this->db->query($sql);

        if($query->num_rows() == 1)
        {
            return  $query->row();
        }   

        return false;
    }


    public function last()
    {
        $query  = $this->db->query("SELECT * FROM $this->table_name ORDER BY id DESC LIMIT 0,1");
        $row    = $query->row();
        return $row->id;
    }

    public function last_tmp()
    {
        $query  = $this->db->query('SELECT * FROM users_tmp ORDER BY id DESC LIMIT 0,1');
        $row    = $query->row();
        return $row->id;
    }

    public function add($data)
    {
        if($this->db->insert($this->table_name, $data))
        {
            return true;
        }

        return false;
    }

    public function add_tmp($data)
    {
        if($this->db->insert('users_tmp', $data))
        {
            return true;
        }

        return false;
    }

    public function update($id = false, $data = array())
    {
        if( ! $id)
        {
            return false;
        }

        $this->db->where('id', $id);

        if($this->db->update($this->table_name, $data))
        {
            return true;
        }

        return false;
    }

    public function delete($user)
    {
        $sql = "DELETE FROM $this->table_name
                WHERE id = $user";

        if($this->db->query($sql))
        {   
            return true;
        }

        return false;
    }

    public function delete_tmp($user)
    {
        $sql = "DELETE FROM users_tmp
                WHERE id = $user";

        if($this->db->query($sql))
        {   
            return true;
        }

        return false;
    }

    public function set_active($id, $active = false)
    {

        $a = $active == true ? 1 : 0;

        $sql = "UPDATE $this->table_name
                SET active = $a
                WHERE id = $id";

        $this->db->query($sql);
    }

    public function autocompletar($key)
    {
        $consulta = $this->db->query("SELECT mail FROM $this->table_name WHERE mail LIKE '%".$key."%' OR lastname LIKE '%".$key."%' LIMIT 0, 8");
        $res = $consulta->result();

        return $res;
    }

    
 
      
}

?>